require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&HAVE_CONFIG_H)) {
    require 'config.ph';
}
unless(defined(&_GNU_SOURCE)) {
    eval 'sub _GNU_SOURCE () {1;}' unless defined(&_GNU_SOURCE);
}
require 'stdio.ph';
require 'assert.ph';
if(defined(&HAVE_LIMITS_H)) {
    require 'limits.ph';
}
require 'ctype.ph';
require 'setjmp.ph';
require 'gettext.ph';
unless(defined(&_)) {
    sub _ {
	local($msgid) = @_;
	eval q( &gettext($msgid));
    }
}
unless(defined(&N_)) {
    sub N_ {
	local($msgid) = @_;
	eval q($msgid);
    }
}
if(! (defined( &HAVE_LIBINTL_H)  && defined( &ENABLE_NLS)  && (defined(&ENABLE_NLS) ? &ENABLE_NLS : 0) > 0)) {
    unless(defined(&LOCALEDIR)) {
	eval 'sub LOCALEDIR () { &NULL;}' unless defined(&LOCALEDIR);
    }
}
if(defined( &HAVE_STDARG_H)  && defined( &__STDC__)  && (defined(&__STDC__) ? &__STDC__ : 0)) {
    require 'stdarg.ph';
} else {
    require 'varargs.ph';
}
require 'signal.ph';
require 'time.ph';
require 'errno.ph';
if(! defined( &errno)  && ! defined( &MSDOS)  && ! defined( &OS2)) {
}
if(defined(&HAVE_SIGNUM_H)) {
    require 'signum.ph';
}
if(defined( &HAVE_MBRLEN)  && defined( &HAVE_MBRTOWC)  && defined( &HAVE_WCHAR_H)  && defined( &HAVE_WCTYPE_H)) {
    eval 'sub MBS_SUPPORT () {1;}' unless defined(&MBS_SUPPORT);
    require 'wchar.ph';
    require 'wctype.ph';
}
if(defined( &STDC_HEADERS) || (!defined( &isascii)  && !defined( &HAVE_ISASCII))) {
    eval 'sub IN_CTYPE_DOMAIN {
        local($c) = @_;
	    eval q(1);
    }' unless defined(&IN_CTYPE_DOMAIN);
} else {
    eval 'sub IN_CTYPE_DOMAIN {
        local($c) = @_;
	    eval q( &isascii( $c));
    }' unless defined(&IN_CTYPE_DOMAIN);
}
if(defined(&isblank)) {
    eval 'sub ISBLANK {
        local($c) = @_;
	    eval q(( &IN_CTYPE_DOMAIN  &&  &isblank( $c)));
    }' unless defined(&ISBLANK);
} else {
    eval 'sub ISBLANK {
        local($c) = @_;
	    eval q((($c) == ord(\' \' || (c) == \'\\\\t\')));
    }' unless defined(&ISBLANK);
}
if(defined(&isgraph)) {
    eval 'sub ISGRAPH {
        local($c) = @_;
	    eval q(( &IN_CTYPE_DOMAIN  &&  &isgraph( $c)));
    }' unless defined(&ISGRAPH);
} else {
    eval 'sub ISGRAPH {
        local($c) = @_;
	    eval q(( &IN_CTYPE_DOMAIN  &&  &isprint  && ! &isspace( $c)));
    }' unless defined(&ISGRAPH);
}
unless(defined(&ISPRINT)) {
    sub ISPRINT {
	local($c) = @_;
	eval q(( &IN_CTYPE_DOMAIN  &&  &isprint ( $c)));
    }
}
unless(defined(&ISDIGIT)) {
    sub ISDIGIT {
	local($c) = @_;
	eval q(( &IN_CTYPE_DOMAIN  &&  &isdigit ( $c)));
    }
}
unless(defined(&ISALNUM)) {
    sub ISALNUM {
	local($c) = @_;
	eval q(( &IN_CTYPE_DOMAIN  &&  &isalnum ( $c)));
    }
}
unless(defined(&ISALPHA)) {
    sub ISALPHA {
	local($c) = @_;
	eval q(( &IN_CTYPE_DOMAIN  &&  &isalpha ( $c)));
    }
}
unless(defined(&ISCNTRL)) {
    sub ISCNTRL {
	local($c) = @_;
	eval q(( &IN_CTYPE_DOMAIN  &&  &iscntrl ( $c)));
    }
}
unless(defined(&ISLOWER)) {
    sub ISLOWER {
	local($c) = @_;
	eval q(( &IN_CTYPE_DOMAIN  &&  &islower ( $c)));
    }
}
unless(defined(&ISPUNCT)) {
    sub ISPUNCT {
	local($c) = @_;
	eval q(( &IN_CTYPE_DOMAIN  &&  &ispunct ($c)));
    }
}
unless(defined(&ISSPACE)) {
    sub ISSPACE {
	local($c) = @_;
	eval q(( &IN_CTYPE_DOMAIN  &&  &isspace ( $c)));
    }
}
unless(defined(&ISUPPER)) {
    sub ISUPPER {
	local($c) = @_;
	eval q(( &IN_CTYPE_DOMAIN  &&  &isupper ( $c)));
    }
}
unless(defined(&ISXDIGIT)) {
    sub ISXDIGIT {
	local($c) = @_;
	eval q(( &IN_CTYPE_DOMAIN  &&  &isxdigit ( $c)));
    }
}
unless(defined(&TOUPPER)) {
    eval 'sub TOUPPER {
        local($c) = @_;
	    eval q( &toupper( $c));
    }' unless defined(&TOUPPER);
}
unless(defined(&TOLOWER)) {
    eval 'sub TOLOWER {
        local($c) = @_;
	    eval q( &tolower( $c));
    }' unless defined(&TOLOWER);
}
if(defined(&__STDC__)) {
    eval 'sub P {
        local($s) = @_;
	    eval q($s);
    }' unless defined(&P);
    eval 'sub MALLOC_ARG_T () { &size_t;}' unless defined(&MALLOC_ARG_T);
} else {
    eval 'sub P {
        local($s) = @_;
	    eval q(());
    }' unless defined(&P);
    eval 'sub MALLOC_ARG_T () {\'unsigned\';}' unless defined(&MALLOC_ARG_T);
    eval 'sub volatile () {1;}' unless defined(&volatile);
}
unless(defined(&VMS)) {
    require 'sys/types.ph';
    require 'sys/stat.ph';
} else {
    require 'stddef.ph';
    require 'stat.ph';
    require 'file.ph';
}
if(! defined( &S_ISREG)  && defined( &S_IFREG)) {
    eval 'sub S_ISREG {
        local($m) = @_;
	    eval q(((($m) &  &S_IFMT) ==  &S_IFREG));
    }' unless defined(&S_ISREG);
}
if(defined(&STDC_HEADERS)) {
    require 'stdlib.ph';
} else {
    require 'protos.ph';
}
if(defined(&HAVE_STRING_H)) {
    require 'string.ph';
    if(defined(&NEED_MEMORY_H)) {
	require 'memory.ph';
    }
} else {
    if(defined(&HAVE_STRINGS_H)) {
	require 'strings.ph';
    }
}
if(defined(&NeXT)) {
    if((defined(&__GNUC__) ? &__GNUC__ : 0) < 2|| (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) < 7) {
	require 'libc.ph';
    }
    undef(&atof) if defined(&atof);
    eval 'sub getopt () { &GNU_getopt;}' unless defined(&getopt);
    eval 'sub GFMT_WORKAROUND () {1;}' unless defined(&GFMT_WORKAROUND);
}
if(defined( &atarist) || defined( &VMS)) {
    require 'unixlib.ph';
}
if(! defined( &MSDOS)  && ! defined( &OS2)  && ! defined( &WIN32)  && ! defined( &__EMX__)  && ! defined( &__CYGWIN__)  && ! defined( &O_BINARY) ) {
    eval 'sub O_BINARY () {0;}' unless defined(&O_BINARY);
}
if(defined( &TANDEM)) {
    eval 'sub variable () { &variabl;}' unless defined(&variable);
    eval 'sub open {
        local($name, $how, $mode) = @_;
	    eval q( &open($name, $how));
    }' unless defined(&open);
}
if((defined(&HAVE_UNISTD_H) ? &HAVE_UNISTD_H : 0)) {
    require 'unistd.ph';
}
unless(defined(&HAVE_VPRINTF)) {
    if(defined(&HAVE_DOPRNT)) {
	eval 'sub vfprintf {
	    local($fp,$fmt,$arg) = @_;
    	    eval q( &_doprnt(($fmt), ($arg), ($fp)));
	}' unless defined(&vfprintf);
    } else {
    }
}
unless(defined(&HAVE_SETLOCALE)) {
    eval 'sub setlocale {
        local($locale, $val) = @_;
	    eval q();
    }' unless defined(&setlocale);
}
unless(defined(&lintwarn)) {
    sub lintwarn () {	(*( &set_loc( &__FILE__,  &__LINE__), &lintfunc));}
}
if(defined(&VMS)) {
    require 'vms/redirect.ph';
}
if(defined(&atarist)) {
    require 'unsupported/atari/redirect.ph';
}
unless(defined(&RE_TRANSLATE_TYPE)) {
    sub RE_TRANSLATE_TYPE () {	 &const 'char' *;}
}
unless(defined(&GNU_REGEX)) {
    sub GNU_REGEX () {	1;}
}
if(defined(&GNU_REGEX)) {
    require 'regex.ph';
    eval 'sub RESTART {
        local($rp,$s) = @_;
	    eval q(($rp)-> ($regs->{start[0]}));
    }' unless defined(&RESTART);
    eval 'sub REEND {
        local($rp,$s) = @_;
	    eval q(($rp)-> ($regs->{end[0]}));
    }' unless defined(&REEND);
    eval 'sub SUBPATSTART {
        local($rp,$s,$n) = @_;
	    eval q(($rp)-> ($regs->{start[$n]}));
    }' unless defined(&SUBPATSTART);
    eval 'sub SUBPATEND {
        local($rp,$s,$n) = @_;
	    eval q(($rp)-> ($regs->{e$nd[$n]}));
    }' unless defined(&SUBPATEND);
    eval 'sub NUMSUBPATS {
        local($rp,$s) = @_;
	    eval q(($rp)-> ($regs->{num_regs}));
    }' unless defined(&NUMSUBPATS);
}
if(defined(&STRTOD_NOT_C89)) {
    eval 'sub strtod () { &gawk_strtod;}' unless defined(&strtod);
}
if((defined(&__GNUC__) ? &__GNUC__ : 0) < 2|| ((defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) < 7)) {
    eval 'sub __attribute__ {
        local($x) = @_;
	    eval q();
    }' unless defined(&__attribute__);
}
unless(defined(&ATTRIBUTE_UNUSED)) {
    eval 'sub ATTRIBUTE_UNUSED () { &__attribute__ (( &__unused__));}' unless defined(&ATTRIBUTE_UNUSED);
}
unless(defined(&ATTRIBUTE_NORETURN)) {
    eval 'sub ATTRIBUTE_NORETURN () { &__attribute__ (( &__noreturn__));}' unless defined(&ATTRIBUTE_NORETURN);
}
unless(defined(&ATTRIBUTE_PRINTF)) {
    eval 'sub ATTRIBUTE_PRINTF {
        local($m, $n) = @_;
	    eval q( &__attribute__ (( &__format__ ( &__printf__, $m, $n))));
    }' unless defined(&ATTRIBUTE_PRINTF);
    eval 'sub ATTRIBUTE_PRINTF_1 () { &ATTRIBUTE_PRINTF(1, 2);}' unless defined(&ATTRIBUTE_PRINTF_1);
}
if((defined(&__GNUC__) ? &__GNUC__ : 0) < 2|| ((defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) < 8)) {
    eval 'sub __extension__ () {1;}' unless defined(&__extension__);
}
if(defined( &WIN32_EXTENSION)  && !defined( &ATTRIBUTE_EXPORTED)) {
    eval 'sub ATTRIBUTE_EXPORTED () { &__declspec( &dllimport);}' unless defined(&ATTRIBUTE_EXPORTED);
} else {
    eval 'sub ATTRIBUTE_EXPORTED () {1;}' unless defined(&ATTRIBUTE_EXPORTED);
}
unless(defined(&AWKNUM)) {
    eval 'sub AWKNUM () { &double;}' unless defined(&AWKNUM);
}
unless(defined(&TRUE)) {
    eval 'sub TRUE () {1;}' unless defined(&TRUE);
    eval 'sub FALSE () {0;}' unless defined(&FALSE);
}
unless(defined(&LINT_INVALID)) {
    sub LINT_INVALID () {	1;}
}
unless(defined(&LINT_ALL)) {
    sub LINT_ALL () {	2;}
}
if(defined(&__STDC__)) {
    eval 'sub BELL () {ord(\'\\a\');}' unless defined(&BELL);
} else {
    if(ord('z' - 'a') == 25) {
	if(ord('a') != 97) {
	    eval 'sub BELL () {ord(\'\\207\');}' unless defined(&BELL);
	} else {
	    eval 'sub BELL () {ord(\'\\07\');}' unless defined(&BELL);
	}
    } else {
	eval 'sub BELL () {ord(\'\\057\');}' unless defined(&BELL);
    }
}
eval("sub Node_illegal () { 0; }") unless defined(&Node_illegal);
eval("sub Node_times () { 1; }") unless defined(&Node_times);
eval("sub Node_quotient () { 2; }") unless defined(&Node_quotient);
eval("sub Node_mod () { 3; }") unless defined(&Node_mod);
eval("sub Node_plus () { 4; }") unless defined(&Node_plus);
eval("sub Node_minus () { 5; }") unless defined(&Node_minus);
eval("sub Node_cond_pair () { 6; }") unless defined(&Node_cond_pair);
eval("sub Node_subscript () { 7; }") unless defined(&Node_subscript);
eval("sub Node_concat () { 8; }") unless defined(&Node_concat);
eval("sub Node_exp () { 9; }") unless defined(&Node_exp);
eval("sub Node_preincrement () { 10; }") unless defined(&Node_preincrement);
eval("sub Node_predecrement () { 11; }") unless defined(&Node_predecrement);
eval("sub Node_postincrement () { 12; }") unless defined(&Node_postincrement);
eval("sub Node_postdecrement () { 13; }") unless defined(&Node_postdecrement);
eval("sub Node_unary_minus () { 14; }") unless defined(&Node_unary_minus);
eval("sub Node_field_spec () { 15; }") unless defined(&Node_field_spec);
eval("sub Node_assign () { 16; }") unless defined(&Node_assign);
eval("sub Node_assign_times () { 17; }") unless defined(&Node_assign_times);
eval("sub Node_assign_quotient () { 18; }") unless defined(&Node_assign_quotient);
eval("sub Node_assign_mod () { 19; }") unless defined(&Node_assign_mod);
eval("sub Node_assign_plus () { 20; }") unless defined(&Node_assign_plus);
eval("sub Node_assign_minus () { 21; }") unless defined(&Node_assign_minus);
eval("sub Node_assign_exp () { 22; }") unless defined(&Node_assign_exp);
eval("sub Node_and () { 23; }") unless defined(&Node_and);
eval("sub Node_or () { 24; }") unless defined(&Node_or);
eval("sub Node_equal () { 25; }") unless defined(&Node_equal);
eval("sub Node_notequal () { 26; }") unless defined(&Node_notequal);
eval("sub Node_less () { 27; }") unless defined(&Node_less);
eval("sub Node_greater () { 28; }") unless defined(&Node_greater);
eval("sub Node_leq () { 29; }") unless defined(&Node_leq);
eval("sub Node_geq () { 30; }") unless defined(&Node_geq);
eval("sub Node_match () { 31; }") unless defined(&Node_match);
eval("sub Node_nomatch () { 32; }") unless defined(&Node_nomatch);
eval("sub Node_not () { 33; }") unless defined(&Node_not);
eval("sub Node_rule_list () { 34; }") unless defined(&Node_rule_list);
eval("sub Node_rule_node () { 35; }") unless defined(&Node_rule_node);
eval("sub Node_statement_list () { 36; }") unless defined(&Node_statement_list);
eval("sub Node_switch_body () { 37; }") unless defined(&Node_switch_body);
eval("sub Node_case_list () { 38; }") unless defined(&Node_case_list);
eval("sub Node_if_branches () { 39; }") unless defined(&Node_if_branches);
eval("sub Node_expression_list () { 40; }") unless defined(&Node_expression_list);
eval("sub Node_param_list () { 41; }") unless defined(&Node_param_list);
eval("sub Node_K_if () { 42; }") unless defined(&Node_K_if);
eval("sub Node_K_switch () { 43; }") unless defined(&Node_K_switch);
eval("sub Node_K_case () { 44; }") unless defined(&Node_K_case);
eval("sub Node_K_default () { 45; }") unless defined(&Node_K_default);
eval("sub Node_K_while () { 46; }") unless defined(&Node_K_while);
eval("sub Node_K_for () { 47; }") unless defined(&Node_K_for);
eval("sub Node_K_arrayfor () { 48; }") unless defined(&Node_K_arrayfor);
eval("sub Node_K_break () { 49; }") unless defined(&Node_K_break);
eval("sub Node_K_continue () { 50; }") unless defined(&Node_K_continue);
eval("sub Node_K_print () { 51; }") unless defined(&Node_K_print);
eval("sub Node_K_print_rec () { 52; }") unless defined(&Node_K_print_rec);
eval("sub Node_K_printf () { 53; }") unless defined(&Node_K_printf);
eval("sub Node_K_next () { 54; }") unless defined(&Node_K_next);
eval("sub Node_K_exit () { 55; }") unless defined(&Node_K_exit);
eval("sub Node_K_do () { 56; }") unless defined(&Node_K_do);
eval("sub Node_K_return () { 57; }") unless defined(&Node_K_return);
eval("sub Node_K_delete () { 58; }") unless defined(&Node_K_delete);
eval("sub Node_K_delete_loop () { 59; }") unless defined(&Node_K_delete_loop);
eval("sub Node_K_getline () { 60; }") unless defined(&Node_K_getline);
eval("sub Node_K_function () { 61; }") unless defined(&Node_K_function);
eval("sub Node_K_nextfile () { 62; }") unless defined(&Node_K_nextfile);
eval("sub Node_redirect_output () { 63; }") unless defined(&Node_redirect_output);
eval("sub Node_redirect_append () { 64; }") unless defined(&Node_redirect_append);
eval("sub Node_redirect_pipe () { 65; }") unless defined(&Node_redirect_pipe);
eval("sub Node_redirect_pipein () { 66; }") unless defined(&Node_redirect_pipein);
eval("sub Node_redirect_input () { 67; }") unless defined(&Node_redirect_input);
eval("sub Node_redirect_twoway () { 68; }") unless defined(&Node_redirect_twoway);
eval("sub Node_var_new () { 69; }") unless defined(&Node_var_new);
eval("sub Node_var () { 70; }") unless defined(&Node_var);
eval("sub Node_var_array () { 71; }") unless defined(&Node_var_array);
eval("sub Node_val () { 72; }") unless defined(&Node_val);
eval("sub Node_builtin () { 73; }") unless defined(&Node_builtin);
eval("sub Node_line_range () { 74; }") unless defined(&Node_line_range);
eval("sub Node_in_array () { 75; }") unless defined(&Node_in_array);
eval("sub Node_func () { 76; }") unless defined(&Node_func);
eval("sub Node_func_call () { 77; }") unless defined(&Node_func_call);
eval("sub Node_cond_exp () { 78; }") unless defined(&Node_cond_exp);
eval("sub Node_regex () { 79; }") unless defined(&Node_regex);
eval("sub Node_dynregex () { 80; }") unless defined(&Node_dynregex);
eval("sub Node_hashnode () { 81; }") unless defined(&Node_hashnode);
eval("sub Node_ahash () { 82; }") unless defined(&Node_ahash);
eval("sub Node_array_ref () { 83; }") unless defined(&Node_array_ref);
eval("sub Node_BINMODE () { 84; }") unless defined(&Node_BINMODE);
eval("sub Node_CONVFMT () { 85; }") unless defined(&Node_CONVFMT);
eval("sub Node_FIELDWIDTHS () { 86; }") unless defined(&Node_FIELDWIDTHS);
eval("sub Node_FNR () { 87; }") unless defined(&Node_FNR);
eval("sub Node_FS () { 88; }") unless defined(&Node_FS);
eval("sub Node_IGNORECASE () { 89; }") unless defined(&Node_IGNORECASE);
eval("sub Node_LINT () { 90; }") unless defined(&Node_LINT);
eval("sub Node_NF () { 91; }") unless defined(&Node_NF);
eval("sub Node_NR () { 92; }") unless defined(&Node_NR);
eval("sub Node_OFMT () { 93; }") unless defined(&Node_OFMT);
eval("sub Node_OFS () { 94; }") unless defined(&Node_OFS);
eval("sub Node_ORS () { 95; }") unless defined(&Node_ORS);
eval("sub Node_RS () { 96; }") unless defined(&Node_RS);
eval("sub Node_TEXTDOMAIN () { 97; }") unless defined(&Node_TEXTDOMAIN);
eval("sub Node_final () { 98; }") unless defined(&Node_final);
unless(defined(&CASE)) {
    sub CASE () {	1;}
}
unless(defined(&CONST)) {
    sub CONST () {	2;}
}
unless(defined(&FS_DFLT)) {
    sub FS_DFLT () {	4;}
}
unless(defined(&hnext)) {
    sub hnext () {	 ($sub->{hash}->{next});}
}
unless(defined(&hname)) {
    sub hname () {	 ($sub->{hash}->{name});}
}
unless(defined(&hlength)) {
    sub hlength () {	 ($sub->{hash}->{length});}
}
unless(defined(&hvalue)) {
    sub hvalue () {	 ($sub->{hash}->{value});}
}
unless(defined(&ahnext)) {
    sub ahnext () {	 ($sub->{hash}->{next});}
}
unless(defined(&ahname_str)) {
    sub ahname_str () {	 ($sub->{hash}->{name});}
}
unless(defined(&ahname_len)) {
    sub ahname_len () {	 ($sub->{hash}->{length});}
}
unless(defined(&ahvalue)) {
    sub ahvalue () {	 ($sub->{hash}->{value});}
}
unless(defined(&ahname_ref)) {
    sub ahname_ref () {	 ($sub->{hash}->{ref});}
}
unless(defined(&MALLOC)) {
    sub MALLOC () {	1;}
}
unless(defined(&TEMP)) {
    sub TEMP () {	2;}
}
unless(defined(&PERM)) {
    sub PERM () {	4;}
}
unless(defined(&STRING)) {
    sub STRING () {	8;}
}
unless(defined(&STRCUR)) {
    sub STRCUR () {	16;}
}
unless(defined(&NUMCUR)) {
    sub NUMCUR () {	32;}
}
unless(defined(&NUMBER)) {
    sub NUMBER () {	64;}
}
unless(defined(&MAYBE_NUM)) {
    sub MAYBE_NUM () {	128;}
}
unless(defined(&ARRAYMAXED)) {
    sub ARRAYMAXED () {	256;}
}
unless(defined(&FUNC)) {
    sub FUNC () {	512;}
}
unless(defined(&FIELD)) {
    sub FIELD () {	1024;}
}
unless(defined(&INTLSTR)) {
    sub INTLSTR () {	2048;}
}
unless(defined(&vname)) {
    sub vname () {	 ($sub->{nodep}->{name});}
}
unless(defined(&exec_count)) {
    sub exec_count () {	 ($sub->{nodep}->{reflags});}
}
unless(defined(&lnode)) {
    sub lnode () {	 ($sub->{nodep}->{l}->{lptr});}
}
unless(defined(&nextp)) {
    sub nextp () {	 ($sub->{nodep}->{l}->{lptr});}
}
unless(defined(&rnode)) {
    sub rnode () {	 ($sub->{nodep}->{r}->{rptr});}
}
unless(defined(&source_file)) {
    sub source_file () {	 ($sub->{nodep}->{name});}
}
unless(defined(&source_line)) {
    sub source_line () {	 ($sub->{nodep}->{number});}
}
unless(defined(&param_cnt)) {
    sub param_cnt () {	 ($sub->{nodep}->{number});}
}
unless(defined(&param)) {
    sub param () {	 ($sub->{nodep}->{l}->{param_name});}
}
unless(defined(&parmlist)) {
    sub parmlist () {	 ($sub->{nodep}->{x}->{param_list});}
}
unless(defined(&subnode)) {
    sub subnode () {	 &lnode;}
}
unless(defined(&builtin)) {
    sub builtin () {	 ($sub->{nodep}->{r}->{pptr});}
}
unless(defined(&callresult)) {
    sub callresult () {	 ($sub->{nodep}->{x}->{extra});}
}
unless(defined(&funcbody)) {
    sub funcbody () {	 ($sub->{nodep}->{x}->{extra});}
}
unless(defined(&re_reg)) {
    sub re_reg () {	 ($sub->{nodep}->{r}->{preg});}
}
unless(defined(&re_flags)) {
    sub re_flags () {	 ($sub->{nodep}->{reflags});}
}
unless(defined(&re_text)) {
    sub re_text () {	 &lnode;}
}
unless(defined(&re_exp)) {
    sub re_exp () {	 ($sub->{nodep}->{x}->{extra});}
}
unless(defined(&forloop)) {
    sub forloop () {	 ($rnode->{sub}->{nodep}->{r}->{hd});}
}
unless(defined(&stptr)) {
    sub stptr () {	 ($sub->{val}->{sp});}
}
unless(defined(&stlen)) {
    sub stlen () {	 ($sub->{val}->{slen});}
}
unless(defined(&stref)) {
    sub stref () {	 ($sub->{val}->{sref});}
}
unless(defined(&stfmt)) {
    sub stfmt () {	 ($sub->{val}->{idx});}
}
unless(defined(&numbr)) {
    sub numbr () {	 ($sub->{val}->{fltnum});}
}
unless(defined(&var_value)) {
    sub var_value () {	 &lnode;}
}
unless(defined(&var_array)) {
    sub var_array () {	 ($sub->{nodep}->{r}->{av});}
}
unless(defined(&array_size)) {
    sub array_size () {	 ($sub->{nodep}->{l}->{ll});}
}
unless(defined(&table_size)) {
    sub table_size () {	 ($sub->{nodep}->{x}->{xl});}
}
unless(defined(&orig_array)) {
    sub orig_array () {	 ($sub->{nodep}->{x}->{extra});}
}
unless(defined(&prev_array)) {
    sub prev_array () {	 &rnode;}
}
unless(defined(&printf_count)) {
    sub printf_count () {	 ($sub->{nodep}->{x}->{xl});}
}
unless(defined(&condpair)) {
    sub condpair () {	 &lnode;}
}
unless(defined(&triggered)) {
    sub triggered () {	 ($sub->{nodep}->{r}->{r_ent});}
}
unless(defined(&IOP_IS_TTY)) {
    sub IOP_IS_TTY () {	1;}
}
unless(defined(&IOP_IS_INTERNAL)) {
    sub IOP_IS_INTERNAL () {	2;}
}
unless(defined(&IOP_NO_FREE)) {
    sub IOP_NO_FREE () {	4;}
}
unless(defined(&IOP_NOFREE_OBJ)) {
    sub IOP_NOFREE_OBJ () {	8;}
}
unless(defined(&IOP_AT_EOF)) {
    sub IOP_AT_EOF () {	16;}
}
unless(defined(&IOP_CLOSED)) {
    sub IOP_CLOSED () {	32;}
}
unless(defined(&RED_FILE)) {
    sub RED_FILE () {	1;}
}
unless(defined(&RED_PIPE)) {
    sub RED_PIPE () {	2;}
}
unless(defined(&RED_READ)) {
    sub RED_READ () {	4;}
}
unless(defined(&RED_WRITE)) {
    sub RED_WRITE () {	8;}
}
unless(defined(&RED_APPEND)) {
    sub RED_APPEND () {	16;}
}
unless(defined(&RED_NOBUF)) {
    sub RED_NOBUF () {	32;}
}
unless(defined(&RED_USED)) {
    sub RED_USED () {	64;}
}
unless(defined(&RED_EOF)) {
    sub RED_EOF () {	128;}
}
unless(defined(&RED_TWOWAY)) {
    sub RED_TWOWAY () {	256;}
}
unless(defined(&RED_PTY)) {
    sub RED_PTY () {	512;}
}
unless(defined(&RED_SOCKET)) {
    sub RED_SOCKET () {	1024;}
}
unless(defined(&RED_TCP)) {
    sub RED_TCP () {	2048;}
}
eval("sub CMDLINE () { 1; }") unless defined(&CMDLINE);
eval("sub SOURCEFILE () { 2; }") unless defined(&SOURCEFILE);
eval("sub PRE_ASSIGN () { 3; }") unless defined(&PRE_ASSIGN);
eval("sub PRE_ASSIGN_FS () { 4; }") unless defined(&PRE_ASSIGN_FS);
unless(defined(&TAG_CONTINUE)) {
    sub TAG_CONTINUE () {	1;}
}
unless(defined(&TAG_BREAK)) {
    sub TAG_BREAK () {	2;}
}
unless(defined(&TAG_RETURN)) {
    sub TAG_RETURN () {	3;}
}
unless(defined(&LONG_MAX)) {
    eval 'sub LONG_MAX () {((~(1 << ($sizeof{\'long\'} * 8- 1))));}' unless defined(&LONG_MAX);
}
unless(defined(&ULONG_MAX)) {
    eval 'sub ULONG_MAX () {(~0);}' unless defined(&ULONG_MAX);
}
unless(defined(&LONG_MIN)) {
    eval 'sub LONG_MIN () {((- &LONG_MAX - 1));}' unless defined(&LONG_MIN);
}
unless(defined(&HUGE)) {
    sub HUGE () {	 &LONG_MAX;}
}
if((defined(&__GNUC__) ? &__GNUC__ : 0) < 2) {
    if(defined( &WIN32_EXTENSION)) {
    } else {
    }
}
if(defined(&NO_LINT)) {
    eval 'sub do_lint () {0;}' unless defined(&do_lint);
    eval 'sub do_lint_old () {0;}' unless defined(&do_lint_old);
} else {
}
if(defined(&MBS_SUPPORT)) {
}
if(defined ( &HAVE_GETGROUPS)  && defined( &NGROUPS_MAX)  && (defined(&NGROUPS_MAX) ? &NGROUPS_MAX : 0) > 0) {
}
unless(defined(&is_identchar)) {
    sub is_identchar {
	local($c) = @_;
	eval q(( &isalnum($c) || ($c) == ord('_')));
    }
}
unless(defined(&isnondecimal)) {
    sub isnondecimal {
	local($str) = @_;
	eval q(((($str)[0]) == ord('0' && (ISDIGIT((str)[1]) 					|| (str)[1] == 'x' || (str)[1] == 'X'))));
    }
}
unless(defined(&var_uninitialized)) {
    sub var_uninitialized {
	local($n) = @_;
	eval q((($n)-> &var_value ==  &Nnull_string));
    }
}
if(defined(&MPROF)) {
    eval 'sub getnode {
        local($n) = @_;
	    eval q( &emalloc(($n),  &NODE *, $sizeof{ &NODE}, \\"getnode\\"), ($n)-> &flags = 0, ($n)- &exec_count = 0;);
    }' unless defined(&getnode);
    eval 'sub freenode {
        local($n) = @_;
	    eval q( &free($n));
    }' unless defined(&freenode);
} else {
    eval 'sub getnode {
        local($n) = @_;
	    eval q( &if $n =  &nextfree,  &nextfree =  ($nextfree->{nextp});  &else $n =  &more_nodes());
    }' unless defined(&getnode);
    unless(defined(&NO_PROFILING)) {
	eval 'sub freenode {
	    local($n) = @_;
    	    eval q((($n)-> &flags = 0, ($n)-> &exec_count = 0, ($n)-> &nextp =  &nextfree,  &nextfree = ($n)));
	}' unless defined(&freenode);
    } else {
	eval 'sub freenode {
	    local($n) = @_;
    	    eval q((($n)-> &flags = 0, ($n)-> &nextp =  &nextfree,  &nextfree = ($n)));
	}' unless defined(&freenode);
    }
}
unless(defined(&GAWKDEBUG)) {
    eval 'sub DUPNODE_MACRO () {1;}' unless defined(&DUPNODE_MACRO);
    eval 'sub DUPNODE_COMMON () {( ($_t->{flags}) & ( &TEMP| &PERM)) != 0? ( ($_t->{flags}) &= ~ &TEMP,  ($_t->{flags}) |=  &MALLOC,  &_t) :  &r_dupnode( &_t);}' unless defined(&DUPNODE_COMMON);
    if((defined(&__GNUC__) ? &__GNUC__ : 0) >= 2) {
	eval 'sub dupnode {
	    local($n) = @_;
    	    eval q(({ &NODE *  &_t = ($n);  &DUPNODE_COMMON;}));
	}' unless defined(&dupnode);
    } else {
	eval 'sub dupnode {
	    local($n) = @_;
    	    eval q(( &_t = ($n),  &DUPNODE_COMMON));
	}' unless defined(&dupnode);
    }
} else {
    eval 'sub dupnode {
        local($n) = @_;
	    eval q( &r_dupnode($n));
    }' unless defined(&dupnode);
}
unless(defined(&get_array)) {
    sub get_array {
	local($t) = @_;
	eval q( &get_actual($t,  &TRUE));
    }
}
unless(defined(&get_param)) {
    sub get_param {
	local($t) = @_;
	eval q( &get_actual($t,  &FALSE));
    }
}
if(defined(&MEMDEBUG)) {
    undef(&freenode) if defined(&freenode);
    eval 'sub get_lhs {
        local($p, $a, $r) = @_;
	    eval q( &r_get_lhs(($p), ($a), ($r)));
    }' unless defined(&get_lhs);
    eval 'sub m_tree_eval {
        local($t, $iscond) = @_;
	    eval q( &r_tree_eval($t, $iscond));
    }' unless defined(&m_tree_eval);
} else {
    eval 'sub get_lhs {
        local($p, $a, $r) = @_;
	    eval q((($p)-> &type ==  &Node_var  && !  &var_uninitialized($p) ? (($p)-> &var_value) :  &r_get_lhs(($p), ($a), ($r))));
    }' unless defined(&get_lhs);
    eval 'sub TREE_EVAL_MACRO () {1;}' unless defined(&TREE_EVAL_MACRO);
    if((defined(&__GNUC__) ? &__GNUC__ : 0) >= 2) {
	eval 'sub m_tree_eval {
	    local($t, $iscond) = @_;
    	    eval q( &__extension__ ({ &NODE *  &_t = ($t);  &if ( &_t ==  &NULL)  &_t =  &Nnull_string;  &else {  &switch( ($_$t->{type})) {  &case  &Node_val:  &if ( ($_$t->{flags})& &INTLSTR)  &_t =  &r_force_string( &_t);  &break;  &case  &Node_var:  &if (!  &var_uninitialized( &_t)) {  &_t =  ($_$t->{var_value});  &break; }  &default:  &_t =  &r_tree_eval( &_t, $iscond);  &break; } }  &_t;}));
	}' unless defined(&m_tree_eval);
    } else {
	eval 'sub m_tree_eval {
	    local($t, $iscond) = @_;
    	    eval q(( &_t = ($t),  &_t ==  &NULL ?  &Nnull_string : ( ($_$t->{type}) ==  &Node_param_list ?  &r_tree_eval( &_t, $iscond) : (( ($_$t->{type}) ==  &Node_val  && ( ($_$t->{flags})& &INTLSTR)) ?  &r_force_string( &_t) : ( ($_$t->{type}) ==  &Node_val ?  &_t : ( ($_$t->{type}) ==  &Node_var  && !  &var_uninitialized( &_t) ?  ($_$t->{var_value}) :  &r_tree_eval( &_t, $iscond)))))));
	}' unless defined(&m_tree_eval);
    }
}
unless(defined(&tree_eval)) {
    sub tree_eval {
	local($t) = @_;
	eval q( &m_tree_eval($t,  &FALSE));
    }
}
unless(defined(&make_number)) {
    sub make_number {
	local($x) = @_;
	eval q( &mk_number(, ( &MALLOC| &NUMCUR| &NUMBER)));
    }
}
unless(defined(&tmp_number)) {
    sub tmp_number {
	local($x) = @_;
	eval q( &mk_number(, ( &MALLOC| &TEMP| &NUMCUR| &NUMBER)));
    }
}
unless(defined(&free_temp)) {
    sub free_temp {
	local($n) = @_;
	eval q( &do {  &NODE * &_n = ($n);  &if ( ($_$n->{flags})& &TEMP)  &unref( &_n);}  &while ( &FALSE));
    }
}
unless(defined(&make_string)) {
    sub make_string {
	local($s, $l) = @_;
	eval q( &make_str_node(, ($l), 0));
    }
}
unless(defined(&SCAN)) {
    sub SCAN () {	1;}
}
unless(defined(&ALREADY_MALLOCED)) {
    sub ALREADY_MALLOCED () {	2;}
}
unless(defined(&cant_happen)) {
    sub cant_happen () {
	eval q( &r_fatal(\"internal error line %d, file: %s\",  &__LINE__,  &__FILE__));
    }
}
if(defined(&HAVE_STRINGIZE)) {
    eval 'sub emalloc {
        local($var,$ty,$x,$str) = @_;
	    eval q((($var= &malloc()) || ( &fatal( &_(\\"%s: %s: can\'t allocate %ld bytes of memory (%s)\\"), , $var, ($x),  &strerror( &errno)),0)));
    }' unless defined(&emalloc);
    eval 'sub erealloc {
        local($var,$ty,$x,$str) = @_;
	    eval q((($var= &realloc($var, )) || ( &fatal( &_(\\"%s: %s: can\'t allocate %ld bytes of memory (%s)\\"), , $var, ($x),  &strerror( &errno)),0)));
    }' unless defined(&erealloc);
} else {
    eval 'sub emalloc {
        local($var,$ty,$x,$str) = @_;
	    eval q((($var= &malloc()) || ( &fatal( &_(\\"%s: %s: can\'t allocate %ld bytes of memory (%s)\\"), , \\"var\\", ($x),  &strerror( &errno)),0)));
    }' unless defined(&emalloc);
    eval 'sub erealloc {
        local($var,$ty,$x,$str) = @_;
	    eval q((($var= &realloc($var, )) || ( &fatal( &_(\\"%s: %s: can\'t allocate %ld bytes of memory (%s)\\"), , \\"var\\", ($x),  &strerror( &errno)),0)));
    }' unless defined(&erealloc);
}
if(defined(&GAWKDEBUG)) {
    eval 'sub force_number () { &r_force_number;}' unless defined(&force_number);
    eval 'sub force_string () { &r_force_string;}' unless defined(&force_string);
} else {
    if(defined(&lint)) {
    }
    if((defined(&__GNUC__) ? &__GNUC__ : 0) >= 2) {
	eval 'sub force_number {
	    local($n) = @_;
    	    eval q( &__extension__ ({ &NODE * &_tn = ($n); ( ($_tn->{flags}) &  &NUMCUR) ? ($_tn->{numbr}) :  &r_force_number( &_tn);}));
	}' unless defined(&force_number);
	eval 'sub force_string {
	    local($s) = @_;
    	    eval q( &__extension__ ({ &NODE * &_ts = ($s); (( ($_ts->{flags}) &  &INTLSTR) ?  &r_force_string( &_ts) : (( ($_ts->{flags}) &  &STRCUR)  && ( ($_ts->{stfmt}) == -1||  ($_ts->{stfmt}) ==  &CONVFMTidx)) ?  &_ts :  &r_force_string( &_ts));}));
	}' unless defined(&force_string);
    } else {
	if(defined(&MSDOS)) {
	    eval 'sub force_number {
	        local($n) = @_;
    		eval q(( &_msc51bug=( &_t = ($n), ( ($_t->{flags}) &  &NUMCUR) ?  ($_t->{numbr}) :  &r_force_number( &_t))));
	    }' unless defined(&force_number);
	} else {
	    eval 'sub force_number {
	        local($n) = @_;
    		eval q(( &_t = ($n), ( ($_t->{flags}) &  &NUMCUR) ?  ($_t->{numbr}) :  &r_force_number( &_t)));
	    }' unless defined(&force_number);
	}
	eval 'sub force_string {
	    local($s) = @_;
    	    eval q(( &_t = ($s),( ($_t->{flags}) &  &INTLSTR) ?  &r_force_string( &_t) : (( ($_t->{flags}) &  &STRCUR)  && ( ($_t->{stfmt}) == -1||  ($_t->{stfmt}) ==  &CONVFMTidx))?  &_t :  &r_force_string( &_t)));
	}' unless defined(&force_string);
    }
}
unless(defined(&STREQ)) {
    sub STREQ {
	local($a,$b) = @_;
	eval q((*($a) == *($b)  &&  &strcmp(($a), ($b)) == 0));
    }
}
unless(defined(&STREQN)) {
    sub STREQN {
	local($a,$b,$n) = @_;
	eval q((  && *== *  &&  &strncmp(, , ($n)) == 0));
    }
}
unless(defined(&fatal)) {
    sub fatal () {	 &set_loc( &__FILE__,  &__LINE__),  &r_fatal;}
}
if(defined(&MBS_SUPPORT)) {
}
if(defined(&PROFILING)) {
}
if(defined(&DYNAMIC)) {
}
if(defined( &_MSC_VER)  && !defined( &_WIN32)) {
    eval 'sub memcpy () {\'memcpy_ulong\';}' unless defined(&memcpy);
    eval 'sub memset () {\'memset_ulong\';}' unless defined(&memset);
}
if((defined(&_MSC_VER) ? &_MSC_VER : 0) == 510) {
} else {
    if(defined( &HAVE_STDARG_H)  && defined( &__STDC__)  && (defined(&__STDC__) ? &__STDC__ : 0)) {
	if((defined(&__GNUC__) ? &__GNUC__ : 0) > 3|| ((defined(&__GNUC__) ? &__GNUC__ : 0) == 3 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) >= 2)) {
	} else {
	}
    } else {
    }
}
if(defined(&MEMDEBUG)) {
}
unless(defined(&BROKEN_STRNCASECMP)) {
}
if(defined( &atarist)) {
    if(defined( &PIPES_SIMULATED)) {
    } else {
	require 'wait.ph';
    }
    require 'fcntl.ph';
    eval 'sub INVALID_HANDLE () {( &__SMALLEST_VALID_HANDLE - 1);}' unless defined(&INVALID_HANDLE);
} else {
    eval 'sub INVALID_HANDLE () {(-1);}' unless defined(&INVALID_HANDLE);
}
if(defined(&HAVE_SYS_WAIT_H)) {
    require 'sys/wait.ph';
}
unless(defined(&WEXITSTATUS)) {
    eval 'sub WEXITSTATUS {
        local($stat_val) = @_;
	    eval q(((( ($stat_val)) >> 8) & 0xff));
    }' unless defined(&WEXITSTATUS);
}
unless(defined(&STATIC)) {
    eval 'sub STATIC () { &static;}' unless defined(&STATIC);
}
1;
