require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_REGEX_INTERNAL_H)) {
    eval 'sub _REGEX_INTERNAL_H () {1;}' unless defined(&_REGEX_INTERNAL_H);
    if(defined(&HAVE_CONFIG_H)) {
	require 'config.ph';
    }
    require 'assert.ph';
    require 'ctype.ph';
    if(0) {
	require 'limits.ph';
    }
    require 'stdio.ph';
    require 'stdlib.ph';
    require 'string.ph';
    if(defined (defined(&HAVE_LOCALE_H) ? &HAVE_LOCALE_H : 0) || defined (defined(&_LIBC) ? &_LIBC : 0)) {
	require 'locale.ph';
    }
    if(defined (defined(&HAVE_WCHAR_H) ? &HAVE_WCHAR_H : 0) || defined (defined(&_LIBC) ? &_LIBC : 0)) {
	require 'wchar.ph';
    }
    if(defined (defined(&HAVE_WCTYPE_H) ? &HAVE_WCTYPE_H : 0) || defined (defined(&_LIBC) ? &_LIBC : 0)) {
	require 'wctype.ph';
    }
    if(!defined (defined(&_LIBC) ? &_LIBC : 0)  && !defined (defined(&HAVE_ISBLANK) ? &HAVE_ISBLANK : 0)  && !defined (defined(&isblank) ? &isblank : 0)) {
	eval 'sub isblank {
	    local($ch) = @_;
    	    eval q((($ch) == ord(\' \' || (ch) == \'\\\\t\')));
	}' unless defined(&isblank);
    }
    if(defined(&_LIBC)) {
	unless(defined(&_RE_DEFINE_LOCALE_FUNCTIONS)) {
	    eval 'sub _RE_DEFINE_LOCALE_FUNCTIONS () {1;}' unless defined(&_RE_DEFINE_LOCALE_FUNCTIONS);
	    require 'locale/localeinfo.ph';
	    require 'locale/elem-hash.ph';
	    require 'locale/coll-lookup.ph';
	}
    }
    if(((defined(&HAVE_LIBINTL_H) ? &HAVE_LIBINTL_H : 0)  && (defined(&ENABLE_NLS) ? &ENABLE_NLS : 0)) || defined (defined(&_LIBC) ? &_LIBC : 0)) {
	require 'libintl.ph';
	if(defined(&_LIBC)) {
	    undef(&gettext) if defined(&gettext);
	    eval 'sub gettext {
	        local($msgid) = @_;
    		eval q( &INTUSE ( &INTUSE( &_libc_intl_domainname), $msgid,  &LC_MESSAGES));
	    }' unless defined(&gettext);
	}
    } else {
	eval 'sub gettext {
	    local($msgid) = @_;
    	    eval q(($msgid));
	}' unless defined(&gettext);
    }
    unless(defined(&gettext_noop)) {
	eval 'sub gettext_noop {
	    local($String) = @_;
    	    eval q($String);
	}' unless defined(&gettext_noop);
    }
    if((defined (defined(&MB_CUR_MAX) ? &MB_CUR_MAX : 0)  && (defined(&HAVE_LOCALE_H) ? &HAVE_LOCALE_H : 0)  && (defined(&HAVE_WCTYPE_H) ? &HAVE_WCTYPE_H : 0)  && (defined(&HAVE_WCHAR_H) ? &HAVE_WCHAR_H : 0)  && (defined(&HAVE_WCRTOMB) ? &HAVE_WCRTOMB : 0)  && (defined(&HAVE_MBRTOWC) ? &HAVE_MBRTOWC : 0)  && (defined(&HAVE_WCSCOLL) ? &HAVE_WCSCOLL : 0)) || (defined(&_LIBC) ? &_LIBC : 0)) {
	eval 'sub RE_ENABLE_I18N () {1;}' unless defined(&RE_ENABLE_I18N);
    }
    if((defined(&__GNUC__) ? &__GNUC__ : 0) >= 3) {
	eval 'sub BE {
	    local($expr, $val) = @_;
    	    eval q( &__builtin_expect ($expr, $val));
	}' unless defined(&BE);
    } else {
	eval 'sub BE {
	    local($expr, $val) = @_;
    	    eval q(($expr));
	}' unless defined(&BE);
	eval 'sub inline () {1;}' unless defined(&inline);
    }
    eval 'sub BYTE_BITS () {8;}' unless defined(&BYTE_BITS);
    eval 'sub SBC_MAX () {256;}' unless defined(&SBC_MAX);
    eval 'sub COLL_ELEM_LEN_MAX () {8;}' unless defined(&COLL_ELEM_LEN_MAX);
    eval 'sub NEWLINE_CHAR () {ord(\'\\n\');}' unless defined(&NEWLINE_CHAR);
    eval 'sub WIDE_NEWLINE_CHAR () { &Lord(\'\\n\');}' unless defined(&WIDE_NEWLINE_CHAR);
    unless(defined(&_LIBC)) {
	eval 'sub __wctype () { &wctype;}' unless defined(&__wctype);
	eval 'sub __iswctype () { &iswctype;}' unless defined(&__iswctype);
	eval 'sub __btowc () { &btowc;}' unless defined(&__btowc);
	eval 'sub __wcrtomb () { &wcrtomb;}' unless defined(&__wcrtomb);
	eval 'sub attribute_hidden () {1;}' unless defined(&attribute_hidden);
	eval 'sub __thread () {1;}' unless defined(&__thread);
    }
    if((defined(&_LIBC) ? &_LIBC : 0) || (defined(&__GNUC__) ? &__GNUC__ : 0) >= 3) {
	eval 'sub BE {
	    local($expr, $val) = @_;
    	    eval q( &__builtin_expect ($expr, $val));
	}' unless defined(&BE);
    } else {
	eval 'sub BE {
	    local($expr, $val) = @_;
    	    eval q(($expr));
	}' unless defined(&BE);
	eval 'sub inline () {1;}' unless defined(&inline);
    }
    if(defined(&RE_ENABLE_I18N)) {
    }
    eval 'sub UINT_BITS () {($sizeof{\'unsigned int\'} *  &BYTE_BITS);}' unless defined(&UINT_BITS);
    eval 'sub BITSET_UINTS () {(( &SBC_MAX +  &UINT_BITS - 1) /  &UINT_BITS);}' unless defined(&BITSET_UINTS);
    eval 'sub bitset_set {
        local($set,$i) = @_;
	    eval q(($set->[$i /  &UINT_BITS] |= 1 << $i %  &UINT_BITS));
    }' unless defined(&bitset_set);
    eval 'sub bitset_clear {
        local($set,$i) = @_;
	    eval q(($set->[$i /  &UINT_BITS] &= ~(1 << $i %  &UINT_BITS)));
    }' unless defined(&bitset_clear);
    eval 'sub bitset_contain {
        local($set,$i) = @_;
	    eval q(($set->[$i /  &UINT_BITS] & (1 << $i %  &UINT_BITS)));
    }' unless defined(&bitset_contain);
    eval 'sub bitset_empty {
        local($set) = @_;
	    eval q( &memset ($set, 0, $sizeof{\'unsigned int\'} *  &BITSET_UINTS));
    }' unless defined(&bitset_empty);
    eval 'sub bitset_set_all {
        local($set) = @_;
	    eval q( &memset ($set, 255, $sizeof{\'unsigned int\'} *  &BITSET_UINTS));
    }' unless defined(&bitset_set_all);
    eval 'sub bitset_copy {
        local($dest,$src) = @_;
	    eval q( &memcpy ($dest, $src, $sizeof{\'unsigned int\'} *  &BITSET_UINTS));
    }' unless defined(&bitset_copy);
    eval 'sub PREV_WORD_CONSTRAINT () {0x1;}' unless defined(&PREV_WORD_CONSTRAINT);
    eval 'sub PREV_NOTWORD_CONSTRAINT () {0x2;}' unless defined(&PREV_NOTWORD_CONSTRAINT);
    eval 'sub NEXT_WORD_CONSTRAINT () {0x4;}' unless defined(&NEXT_WORD_CONSTRAINT);
    eval 'sub NEXT_NOTWORD_CONSTRAINT () {0x8;}' unless defined(&NEXT_NOTWORD_CONSTRAINT);
    eval 'sub PREV_NEWLINE_CONSTRAINT () {0x10;}' unless defined(&PREV_NEWLINE_CONSTRAINT);
    eval 'sub NEXT_NEWLINE_CONSTRAINT () {0x20;}' unless defined(&NEXT_NEWLINE_CONSTRAINT);
    eval 'sub PREV_BEGBUF_CONSTRAINT () {0x40;}' unless defined(&PREV_BEGBUF_CONSTRAINT);
    eval 'sub NEXT_ENDBUF_CONSTRAINT () {0x80;}' unless defined(&NEXT_ENDBUF_CONSTRAINT);
    eval 'sub DUMMY_CONSTRAINT () {0x100;}' unless defined(&DUMMY_CONSTRAINT);
    eval("sub INSIDE_WORD () { PREV_WORD_CONSTRAINT|NEXT_WORD_CONSTRAINT; }") unless defined(&INSIDE_WORD);
    eval("sub WORD_FIRST () { PREV_NOTWORD_CONSTRAINT|NEXT_WORD_CONSTRAINT; }") unless defined(&WORD_FIRST);
    eval("sub WORD_LAST () { PREV_WORD_CONSTRAINT|NEXT_NOTWORD_CONSTRAINT; }") unless defined(&WORD_LAST);
    eval("sub LINE_FIRST () { PREV_NEWLINE_CONSTRAINT; }") unless defined(&LINE_FIRST);
    eval("sub LINE_LAST () { NEXT_NEWLINE_CONSTRAINT; }") unless defined(&LINE_LAST);
    eval("sub BUF_FIRST () { PREV_BEGBUF_CONSTRAINT; }") unless defined(&BUF_FIRST);
    eval("sub BUF_LAST () { NEXT_ENDBUF_CONSTRAINT; }") unless defined(&BUF_LAST);
    eval("sub WORD_DELIM () { DUMMY_CONSTRAINT; }") unless defined(&WORD_DELIM);
    eval("sub NON_TYPE () { 0; }") unless defined(&NON_TYPE);
    eval("sub OP_OPEN_BRACKET () { 1; }") unless defined(&OP_OPEN_BRACKET);
    eval("sub OP_CLOSE_BRACKET () { 2; }") unless defined(&OP_CLOSE_BRACKET);
    eval("sub OP_CHARSET_RANGE () { 3; }") unless defined(&OP_CHARSET_RANGE);
    eval("sub OP_OPEN_DUP_NUM () { 4; }") unless defined(&OP_OPEN_DUP_NUM);
    eval("sub OP_CLOSE_DUP_NUM () { 5; }") unless defined(&OP_CLOSE_DUP_NUM);
    eval("sub OP_NON_MATCH_LIST () { 6; }") unless defined(&OP_NON_MATCH_LIST);
    eval("sub OP_OPEN_COLL_ELEM () { 7; }") unless defined(&OP_OPEN_COLL_ELEM);
    eval("sub OP_CLOSE_COLL_ELEM () { 8; }") unless defined(&OP_CLOSE_COLL_ELEM);
    eval("sub OP_OPEN_EQUIV_CLASS () { 9; }") unless defined(&OP_OPEN_EQUIV_CLASS);
    eval("sub OP_CLOSE_EQUIV_CLASS () { 10; }") unless defined(&OP_CLOSE_EQUIV_CLASS);
    eval("sub OP_OPEN_CHAR_CLASS () { 11; }") unless defined(&OP_OPEN_CHAR_CLASS);
    eval("sub OP_CLOSE_CHAR_CLASS () { 12; }") unless defined(&OP_CLOSE_CHAR_CLASS);
    eval("sub OP_WORD () { 13; }") unless defined(&OP_WORD);
    eval("sub OP_NOTWORD () { 14; }") unless defined(&OP_NOTWORD);
    eval("sub BACK_SLASH () { 15; }") unless defined(&BACK_SLASH);
    eval("sub CONCAT () { 16; }") unless defined(&CONCAT);
    eval("sub ALT () { 17; }") unless defined(&ALT);
    eval("sub SUBEXP () { 18; }") unless defined(&SUBEXP);
    eval("sub SIMPLE_BRACKET () { 19; }") unless defined(&SIMPLE_BRACKET);
    eval("sub OP_OPEN_SUBEXP () { 20; }") unless defined(&OP_OPEN_SUBEXP);
    eval("sub OP_CLOSE_SUBEXP () { 21; }") unless defined(&OP_CLOSE_SUBEXP);
    eval("sub OP_PERIOD () { 22; }") unless defined(&OP_PERIOD);
    eval("sub CHARACTER () { 23; }") unless defined(&CHARACTER);
    eval("sub END_OF_RE () { 24; }") unless defined(&END_OF_RE);
    eval("sub OP_ALT () { 25; }") unless defined(&OP_ALT);
    eval("sub OP_DUP_ASTERISK () { 26; }") unless defined(&OP_DUP_ASTERISK);
    eval("sub OP_DUP_PLUS () { 27; }") unless defined(&OP_DUP_PLUS);
    eval("sub OP_DUP_QUESTION () { 28; }") unless defined(&OP_DUP_QUESTION);
    eval("sub OP_BACK_REF () { 29; }") unless defined(&OP_BACK_REF);
    eval("sub ANCHOR () { 30; }") unless defined(&ANCHOR);
    eval("sub END_OF_RE_TOKEN_T () { 31; }") unless defined(&END_OF_RE_TOKEN_T);
    if(defined(&RE_ENABLE_I18N)) {
	if(defined(&_LIBC)) {
	}
	if(defined(&_LIBC)) {
	}
	if(defined(&_LIBC)) {
	} else {
	}
    }
    if(defined(&RE_ENABLE_I18N)) {
    }
    if((defined(&__GNUC__) ? &__GNUC__ : 0) >= 2) {
    } else {
    }
    if(defined(&RE_ENABLE_I18N)) {
    }
    eval 'sub IS_EPSILON_NODE {
        local($type) = @_;
	    eval q((($type) ==  &OP_ALT || ($type) ==  &OP_DUP_ASTERISK || ($type) ==  &OP_DUP_PLUS || ($type) ==  &OP_DUP_QUESTION || ($type) ==  &ANCHOR || ($type) ==  &OP_OPEN_SUBEXP || ($type) ==  &OP_CLOSE_SUBEXP));
    }' unless defined(&IS_EPSILON_NODE);
    eval 'sub ACCEPT_MB_NODE {
        local($type) = @_;
	    eval q((($type) ==  &COMPLEX_BRACKET || ($type) ==  &OP_PERIOD));
    }' unless defined(&ACCEPT_MB_NODE);
    if(defined(&RE_ENABLE_I18N)) {
    }
    eval 'sub MBS_ALLOCATED {
        local($pstr) = @_;
	    eval q(( ($pstr->{icase})));
    }' unless defined(&MBS_ALLOCATED);
    eval 'sub MBS_CASE_ALLOCATED {
        local($pstr) = @_;
	    eval q(( ($pstr->{trans}) !=  &NULL));
    }' unless defined(&MBS_CASE_ALLOCATED);
    if(defined(&RE_ENABLE_I18N)) {
    }
    if(defined(&RE_ENABLE_I18N)) {
    }
    eval 'sub re_string_peek_byte {
        local($pstr, $offset) = @_;
	    eval q((($pstr)-> $mbs[($pstr)-> &cur_idx + $offset]));
    }' unless defined(&re_string_peek_byte);
    eval 'sub re_string_peek_byte_case {
        local($pstr, $offset) = @_;
	    eval q((($pstr)-> $mbs_case[($pstr)-> &cur_idx + $offset]));
    }' unless defined(&re_string_peek_byte_case);
    eval 'sub re_string_fetch_byte {
        local($pstr) = @_;
	    eval q((($pstr)-> $mbs[($pstr)-> &cur_idx++]));
    }' unless defined(&re_string_fetch_byte);
    eval 'sub re_string_fetch_byte_case {
        local($pstr) = @_;
	    eval q((($pstr)-> $mbs_case[($pstr)-> &cur_idx++]));
    }' unless defined(&re_string_fetch_byte_case);
    eval 'sub re_string_first_byte {
        local($pstr, $idx) = @_;
	    eval q((($idx) == ($pstr)-> &len || ($pstr)-> $wcs[$idx] !=  &WEOF));
    }' unless defined(&re_string_first_byte);
    eval 'sub re_string_is_single_byte_char {
        local($pstr, $idx) = @_;
	    eval q((($pstr)-> $wcs[$idx] !=  &WEOF  && (($pstr)-> &len == ($idx) || ($pstr)-> $wcs[($idx) + 1] !=  &WEOF)));
    }' unless defined(&re_string_is_single_byte_char);
    eval 'sub re_string_eoi {
        local($pstr) = @_;
	    eval q((($pstr)-> &stop <= ($pstr)-> &cur_idx));
    }' unless defined(&re_string_eoi);
    eval 'sub re_string_cur_idx {
        local($pstr) = @_;
	    eval q((($pstr)-> &cur_idx));
    }' unless defined(&re_string_cur_idx);
    eval 'sub re_string_get_buffer {
        local($pstr) = @_;
	    eval q((($pstr)-> &mbs));
    }' unless defined(&re_string_get_buffer);
    eval 'sub re_string_length {
        local($pstr) = @_;
	    eval q((($pstr)-> &len));
    }' unless defined(&re_string_length);
    eval 'sub re_string_byte_at {
        local($pstr,$idx) = @_;
	    eval q((($pstr)-> $mbs[$idx]));
    }' unless defined(&re_string_byte_at);
    eval 'sub re_string_skip_bytes {
        local($pstr,$idx) = @_;
	    eval q((($pstr)-> &cur_idx += ($idx)));
    }' unless defined(&re_string_skip_bytes);
    eval 'sub re_string_set_index {
        local($pstr,$idx) = @_;
	    eval q((($pstr)-> &cur_idx = ($idx)));
    }' unless defined(&re_string_set_index);
    eval 'sub re_malloc {
        local($t,$n) = @_;
	    eval q((  &malloc (($n) * $sizeof{$t})));
    }' unless defined(&re_malloc);
    eval 'sub re_realloc {
        local($p,$t,$n) = @_;
	    eval q((  &realloc ($p, ($n) * $sizeof{$t})));
    }' unless defined(&re_realloc);
    eval 'sub re_free {
        local($p) = @_;
	    eval q( &free ($p));
    }' unless defined(&re_free);
    eval 'sub CONTEXT_WORD () {1;}' unless defined(&CONTEXT_WORD);
    eval 'sub CONTEXT_NEWLINE () {( &CONTEXT_WORD << 1);}' unless defined(&CONTEXT_NEWLINE);
    eval 'sub CONTEXT_BEGBUF () {( &CONTEXT_NEWLINE << 1);}' unless defined(&CONTEXT_BEGBUF);
    eval 'sub CONTEXT_ENDBUF () {( &CONTEXT_BEGBUF << 1);}' unless defined(&CONTEXT_ENDBUF);
    eval 'sub IS_WORD_CONTEXT {
        local($c) = @_;
	    eval q((($c) &  &CONTEXT_WORD));
    }' unless defined(&IS_WORD_CONTEXT);
    eval 'sub IS_NEWLINE_CONTEXT {
        local($c) = @_;
	    eval q((($c) &  &CONTEXT_NEWLINE));
    }' unless defined(&IS_NEWLINE_CONTEXT);
    eval 'sub IS_BEGBUF_CONTEXT {
        local($c) = @_;
	    eval q((($c) &  &CONTEXT_BEGBUF));
    }' unless defined(&IS_BEGBUF_CONTEXT);
    eval 'sub IS_ENDBUF_CONTEXT {
        local($c) = @_;
	    eval q((($c) &  &CONTEXT_ENDBUF));
    }' unless defined(&IS_ENDBUF_CONTEXT);
    eval 'sub IS_ORDINARY_CONTEXT {
        local($c) = @_;
	    eval q((($c) == 0));
    }' unless defined(&IS_ORDINARY_CONTEXT);
    eval 'sub IS_WORD_CHAR {
        local($ch) = @_;
	    eval q(( &isalnum ($ch) || ($ch) == ord(\'_\')));
    }' unless defined(&IS_WORD_CHAR);
    eval 'sub IS_NEWLINE {
        local($ch) = @_;
	    eval q((($ch) ==  &NEWLINE_CHAR));
    }' unless defined(&IS_NEWLINE);
    eval 'sub IS_WIDE_WORD_CHAR {
        local($ch) = @_;
	    eval q(( &iswalnum ($ch) || ($ch) ==  &Lord(\'_\')));
    }' unless defined(&IS_WIDE_WORD_CHAR);
    eval 'sub IS_WIDE_NEWLINE {
        local($ch) = @_;
	    eval q((($ch) ==  &WIDE_NEWLINE_CHAR));
    }' unless defined(&IS_WIDE_NEWLINE);
    eval 'sub NOT_SATISFY_PREV_CONSTRAINT {
        local($constraint,$context) = @_;
	    eval q((((($constraint) &  &PREV_WORD_CONSTRAINT)  && ! &IS_WORD_CONTEXT ($context)) || (($constraint &  &PREV_NOTWORD_CONSTRAINT)  &&  &IS_WORD_CONTEXT ($context)) || (($constraint &  &PREV_NEWLINE_CONSTRAINT)  && ! &IS_NEWLINE_CONTEXT ($context)) || (($constraint &  &PREV_BEGBUF_CONSTRAINT)  && ! &IS_BEGBUF_CONTEXT ($context))));
    }' unless defined(&NOT_SATISFY_PREV_CONSTRAINT);
    eval 'sub NOT_SATISFY_NEXT_CONSTRAINT {
        local($constraint,$context) = @_;
	    eval q((((($constraint) &  &NEXT_WORD_CONSTRAINT)  && ! &IS_WORD_CONTEXT ($context)) || ((($constraint) &  &NEXT_NOTWORD_CONSTRAINT)  &&  &IS_WORD_CONTEXT ($context)) || ((($constraint) &  &NEXT_NEWLINE_CONSTRAINT)  && ! &IS_NEWLINE_CONTEXT ($context)) || ((($constraint) &  &NEXT_ENDBUF_CONSTRAINT)  && ! &IS_ENDBUF_CONTEXT ($context))));
    }' unless defined(&NOT_SATISFY_NEXT_CONSTRAINT);
    if(defined(&DEBUG)) {
    }
    eval 'sub re_node_set_init_empty {
        local($set) = @_;
	    eval q( &memset ($set, ord(\'\\\\0\'), $sizeof{ &re_node_set}));
    }' unless defined(&re_node_set_init_empty);
    eval 'sub re_node_set_remove {
        local($set,$id) = @_;
	    eval q(( &re_node_set_remove_at ($set,  &re_node_set_contains ($set, $id) - 1)));
    }' unless defined(&re_node_set_remove);
    eval 'sub re_node_set_empty {
        local($p) = @_;
	    eval q((($p)-> &nelem = 0));
    }' unless defined(&re_node_set_empty);
    eval 'sub re_node_set_free {
        local($set) = @_;
	    eval q( &re_free (($set)-> &elems));
    }' unless defined(&re_node_set_free);
    eval("sub SB_CHAR () { 0; }") unless defined(&SB_CHAR);
    eval("sub MB_CHAR () { 1; }") unless defined(&MB_CHAR);
    eval("sub EQUIV_CLASS () { 2; }") unless defined(&EQUIV_CLASS);
    eval("sub COLL_SYM () { 3; }") unless defined(&COLL_SYM);
    eval("sub CHAR_CLASS () { 4; }") unless defined(&CHAR_CLASS);
    if(defined(&RE_ENABLE_I18N)) {
	if(defined(&_LIBC)) {
	    require 'locale/weight.ph';
	}
    }
}
1;
