require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MATH_H)) {
    die("Never use <bits/mathinline.h> directly; include <math.h> instead.");
}
if(defined(&__cplusplus)) {
    eval 'sub __MATH_INLINE () { &__inline;}' unless defined(&__MATH_INLINE);
} else {
    eval 'sub __MATH_INLINE () { &extern  &__inline;}' unless defined(&__MATH_INLINE);
}
if(defined(&__USE_ISOC99)) {
    eval 'sub isunordered {
        local($x, $y) = @_;
	    eval q(( &__extension__ ({  &double  &__r;  &__asm (\\"cmptun/su %1,%2,%0\\\\n\\\\ttrapb\\" : \\"=&f\\" ( &__r) : \\"f\\" ($x), \\"f\\"($y));  &__r != 0; })));
    }' unless defined(&isunordered);
    eval 'sub isgreater {
        local($x, $y) = @_;
	    eval q(( &__extension__ ({  &__typeof__  &__x = ;  &__typeof__  &__y = ($y); ! &isunordered( &__x,  &__y)  &&  &__x >  &__y; })));
    }' unless defined(&isgreater);
    eval 'sub isgreaterequal {
        local($x, $y) = @_;
	    eval q(( &__extension__ ({  &__typeof__  &__x = ;  &__typeof__  &__y = ($y); ! &isunordered( &__x,  &__y)  &&  &__x >=  &__y; })));
    }' unless defined(&isgreaterequal);
    eval 'sub isless {
        local($x, $y) = @_;
	    eval q(( &__extension__ ({  &__typeof__  &__x = ;  &__typeof__  &__y = ($y); ! &isunordered( &__x,  &__y)  &&  &__x <  &__y; })));
    }' unless defined(&isless);
    eval 'sub islessequal {
        local($x, $y) = @_;
	    eval q(( &__extension__ ({  &__typeof__  &__x = ;  &__typeof__  &__y = ($y); ! &isunordered( &__x,  &__y)  &&  &__x <=  &__y; })));
    }' unless defined(&islessequal);
    eval 'sub islessgreater {
        local($x, $y) = @_;
	    eval q(( &__extension__ ({  &__typeof__  &__x = ;  &__typeof__  &__y = ($y); ! &isunordered( &__x,  &__y)  &&  &__x !=  &__y; })));
    }' unless defined(&islessgreater);
}
if((!defined (defined(&__NO_MATH_INLINES) ? &__NO_MATH_INLINES : 0) || defined (defined(&__LIBC_INTERNAL_MATH_INLINES) ? &__LIBC_INTERNAL_MATH_INLINES : 0))  && defined (defined(&__OPTIMIZE__) ? &__OPTIMIZE__ : 0)) {
    eval 'sub __inline_copysign {
        local($NAME, $TYPE) = @_;
	    eval q( &__MATH_INLINE $TYPE $NAME ($TYPE  &__x, $TYPE  &__y)  &__THROW { $TYPE  &__z;  &__asm (\\"cpys %1, %2, %0\\" : \\"=f\\" ( &__z) : \\"f\\" ( &__y), \\"f\\" ( &__x));  &return  &__z; });
    }' unless defined(&__inline_copysign);
    undef(&__MATH_INLINE_copysign) if defined(&__MATH_INLINE_copysign);
    if( &__GNUC_PREREQ (2, 8)) {
    } else {
	eval 'sub __inline_fabs {
	    local($NAME, $TYPE) = @_;
    	    eval q( &__MATH_INLINE $TYPE $NAME  &__THROW { $TYPE  &__z;  &__asm (\\"cpys $f31, %1, %0\\" : \\"=f\\" ( &__z) : \\"f\\" ( &__x));  &return  &__z; });
	}' unless defined(&__inline_fabs);
	undef(&__inline_fabs) if defined(&__inline_fabs);
    }
    if(defined(&_IEEE_FP_INEXACT)) {
    } else {
    }
    if(defined(&_IEEE_FP_INEXACT)) {
    } else {
    }
    if(defined(&__USE_ISOC99)) {
    }
}
1;
