require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_MTD_COMPATMAC_H__)) {
    eval 'sub __LINUX_MTD_COMPATMAC_H__ () {1;}' unless defined(&__LINUX_MTD_COMPATMAC_H__);
    require 'linux/config.ph';
    require 'linux/module.ph';
    unless(defined(&LINUX_VERSION_CODE)) {
	require 'linux/version.ph';
    }
    unless(defined(&VERSION_CODE)) {
	eval 'sub VERSION_CODE {
	    local($vers,$rel,$seq) = @_;
    	    eval q(( (($vers)<<16) | (($rel)<<8) | ($seq) ));
	}' unless defined(&VERSION_CODE);
    }
    unless(defined(&KERNEL_VERSION)) {
	eval 'sub KERNEL_VERSION {
	    local($a,$b,$c) = @_;
    	    eval q( &VERSION_CODE($a,$b,$c));
	}' unless defined(&KERNEL_VERSION);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,0,0)) {
	die("This kernel is too old: not supported by this file");
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,1,0)) {
	require 'linux/types.ph';
	eval 'sub memcpy_fromio {
	    local($a,$b,$c) = @_;
    	    eval q( &memcpy(,($b),($c)));
	}' unless defined(&memcpy_fromio);
	eval 'sub memcpy_toio {
	    local($a,$b,$c) = @_;
    	    eval q( &memcpy(($a),($b),($c)));
	}' unless defined(&memcpy_toio);
	eval 'sub DECLARE_WAITQUEUE {
	    local($x,$y) = @_;
    	    eval q(\'struct wait_queue\' $x = {$y, &NULL});
	}' unless defined(&DECLARE_WAITQUEUE);
	eval 'sub DECLARE_WAIT_QUEUE_HEAD {
	    local($x) = @_;
    	    eval q(\'struct wait_queue\' *$x =  &NULL);
	}' unless defined(&DECLARE_WAIT_QUEUE_HEAD);
	eval 'sub init_waitqueue_head () { &init_waitqueue;}' unless defined(&init_waitqueue_head);
	eval 'sub DECLARE_MUTEX {
	    local($x) = @_;
    	    eval q(\'struct semaphore\' $x =  &MUTEX);
	}' unless defined(&DECLARE_MUTEX);
	eval 'sub DECLARE_MUTEX_LOCKED {
	    local($x) = @_;
    	    eval q(\'struct semaphore\' $x =  &MUTEX_LOCKED);
	}' unless defined(&DECLARE_MUTEX_LOCKED);
	require 'asm/segment.ph';
	eval 'sub access_ok {
	    local($t,$a,$sz) = @_;
    	    eval q(( &verify_area(($t),($a),($sz)) ? 0: 1));
	}' unless defined(&access_ok);
	eval 'sub verify_area_20 () { &verify_area;}' unless defined(&verify_area_20);
	eval 'sub copy_to_user {
	    local($t,$f,$n) = @_;
    	    eval q(( &memcpy_tofs($t,$f,$n), 0));
	}' unless defined(&copy_to_user);
	eval 'sub __copy_to_user {
	    local($t,$f,$n) = @_;
    	    eval q( &copy_to_user(($t),($f),($n)));
	}' unless defined(&__copy_to_user);
	eval 'sub copy_to_user_ret {
	    local($t,$f,$n,$r) = @_;
    	    eval q( &copy_to_user(($t),($f),($n)));
	}' unless defined(&copy_to_user_ret);
	eval 'sub copy_from_user {
	    local($t,$f,$n) = @_;
    	    eval q(( &memcpy_fromfs(($t),($f),($n)), 0));
	}' unless defined(&copy_from_user);
	eval 'sub __copy_from_user {
	    local($t,$f,$n) = @_;
    	    eval q( &copy_from_user(($t),($f),($n)));
	}' unless defined(&__copy_from_user);
	eval 'sub copy_from_user_ret {
	    local($t,$f,$n,$r) = @_;
    	    eval q( &copy_from_user(($t),($f),($n)));
	}' unless defined(&copy_from_user_ret);
	eval 'sub Put_user {
	    local($val,$add) = @_;
    	    eval q(( &put_user(($val),($add)), 0));
	}' unless defined(&Put_user);
	eval 'sub __PUT_USER {
	    local($val,$add) = @_;
    	    eval q( &PUT_USER(($val),($add)));
	}' unless defined(&__PUT_USER);
	eval 'sub PUT_USER_RET {
	    local($val,$add,$ret) = @_;
    	    eval q( &PUT_USER(($val),($add)));
	}' unless defined(&PUT_USER_RET);
	eval 'sub GET_USER {
	    local($dest,$add) = @_;
    	    eval q((($dest)= &get_user(($add)), 0));
	}' unless defined(&GET_USER);
	eval 'sub __GET_USER {
	    local($dest,$add) = @_;
    	    eval q( &GET_USER(($dest),($add)));
	}' unless defined(&__GET_USER);
	eval 'sub GET_USER_RET {
	    local($dest,$add,$ret) = @_;
    	    eval q( &GET_USER(($dest),($add)));
	}' unless defined(&GET_USER_RET);
	eval 'sub ioremap {
	    local($offset,$size) = @_;
    	    eval q( &vremap($offset,$size));
	}' unless defined(&ioremap);
	eval 'sub iounmap {
	    local($adr) = @_;
    	    eval q();
	}' unless defined(&iounmap);
	eval 'sub EXPORT_SYMBOL {
	    local($s) = @_;
    	    eval q();
	}' unless defined(&EXPORT_SYMBOL);
	eval 'sub EXPORT_SYMBOL_NOVERS {
	    local($s) = @_;
    	    eval q();
	}' unless defined(&EXPORT_SYMBOL_NOVERS);
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &VERSION_CODE(2,1,10)) {
	    require 'asm/byteorder.ph';
	    if(defined(&__LITTLE_ENDIAN)) {
		eval 'sub cpu_to_le16 {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&cpu_to_le16);
		eval 'sub cpu_to_le32 {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&cpu_to_le32);
		eval 'sub cpu_to_be16 {
		    local($x) = @_;
    		    eval q( &htons(($x)));
		}' unless defined(&cpu_to_be16);
		eval 'sub cpu_to_be32 {
		    local($x) = @_;
    		    eval q( &htonl(($x)));
		}' unless defined(&cpu_to_be32);
	    } else {
		eval 'sub cpu_to_be16 {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&cpu_to_be16);
		eval 'sub cpu_to_be32 {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&cpu_to_be32);
	    }
	    eval 'sub le16_to_cpu {
	        local($x) = @_;
    		eval q( &cpu_to_le16($x));
	    }' unless defined(&le16_to_cpu);
	    eval 'sub le32_to_cpu {
	        local($x) = @_;
    		eval q( &cpu_to_le32($x));
	    }' unless defined(&le32_to_cpu);
	    eval 'sub be16_to_cpu {
	        local($x) = @_;
    		eval q( &cpu_to_be16($x));
	    }' unless defined(&be16_to_cpu);
	    eval 'sub be32_to_cpu {
	        local($x) = @_;
    		eval q( &cpu_to_be32($x));
	    }' unless defined(&be32_to_cpu);
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &VERSION_CODE(2,1,43)) {
	    eval 'sub cpu_to_le16p {
	        local($addr) = @_;
    		eval q(( &cpu_to_le16(*($addr))));
	    }' unless defined(&cpu_to_le16p);
	    eval 'sub cpu_to_le32p {
	        local($addr) = @_;
    		eval q(( &cpu_to_le32(*($addr))));
	    }' unless defined(&cpu_to_le32p);
	    eval 'sub cpu_to_be16p {
	        local($addr) = @_;
    		eval q(( &cpu_to_be16(*($addr))));
	    }' unless defined(&cpu_to_be16p);
	    eval 'sub cpu_to_be32p {
	        local($addr) = @_;
    		eval q(( &cpu_to_be32(*($addr))));
	    }' unless defined(&cpu_to_be32p);
	    eval 'sub le16_to_cpup {
	        local($x) = @_;
    		eval q( &cpu_to_le16p($x));
	    }' unless defined(&le16_to_cpup);
	    eval 'sub le32_to_cpup {
	        local($x) = @_;
    		eval q( &cpu_to_le32p($x));
	    }' unless defined(&le32_to_cpup);
	    eval 'sub be16_to_cpup {
	        local($x) = @_;
    		eval q( &cpu_to_be16p($x));
	    }' unless defined(&be16_to_cpup);
	    eval 'sub be32_to_cpup {
	        local($x) = @_;
    		eval q( &cpu_to_be32p($x));
	    }' unless defined(&be32_to_cpup);
	    eval 'sub le16_to_cpus {
	        local($x) = @_;
    		eval q( &cpu_to_le16s($x));
	    }' unless defined(&le16_to_cpus);
	    eval 'sub le32_to_cpus {
	        local($x) = @_;
    		eval q( &cpu_to_le32s($x));
	    }' unless defined(&le32_to_cpus);
	    eval 'sub be16_to_cpus {
	        local($x) = @_;
    		eval q( &cpu_to_be16s($x));
	    }' unless defined(&be16_to_cpus);
	    eval 'sub be32_to_cpus {
	        local($x) = @_;
    		eval q( &cpu_to_be32s($x));
	    }' unless defined(&be32_to_cpus);
	}
	unless(defined(&__BIT_TYPES_DEFINED__)) {
	    eval 'sub __BIT_TYPES_DEFINED__ () {1;}' unless defined(&__BIT_TYPES_DEFINED__);
	}
	if(((defined(&__GNUC__) ? &__GNUC__ : 0) > 2) || ((defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) >= 8)) {
	    eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) { };}' unless defined(&SPIN_LOCK_UNLOCKED);
	} else {
	    eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) { 0};}' unless defined(&SPIN_LOCK_UNLOCKED);
	}
	eval 'sub spin_lock_init {
	    local($lock) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&spin_lock_init);
	eval 'sub spin_lock {
	    local($lock) = @_;
    	    eval q(($lock));
	}' unless defined(&spin_lock);
	eval 'sub spin_trylock {
	    local($lock) = @_;
    	    eval q((1));
	}' unless defined(&spin_trylock);
	eval 'sub spin_unlock_wait {
	    local($lock) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&spin_unlock_wait);
	eval 'sub spin_unlock {
	    local($lock) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&spin_unlock);
	eval 'sub spin_lock_irq {
	    local($lock) = @_;
    	    eval q( &cli());
	}' unless defined(&spin_lock_irq);
	eval 'sub spin_unlock_irq {
	    local($lock) = @_;
    	    eval q( &sti());
	}' unless defined(&spin_unlock_irq);
	eval 'sub spin_lock_irqsave {
	    local($lock, $flags) = @_;
    	    eval q( &do {  &save_flags($flags);  &cli(); }  &while (0));
	}' unless defined(&spin_lock_irqsave);
	eval 'sub spin_unlock_irqrestore {
	    local($lock, $flags) = @_;
    	    eval q( &restore_flags($flags));
	}' unless defined(&spin_unlock_irqrestore);
	eval 'sub tty_flip_buffer_push {
	    local($tty) = @_;
    	    eval q( &queue_task_irq_off( ($tty->{flip}->{tqueue}),  &tq_timer));
	}' unless defined(&tty_flip_buffer_push);
	eval 'sub signal_pending {
	    local($current) = @_;
    	    eval q(( ($current->{signal}) & ~ ($current->{blocked})));
	}' unless defined(&signal_pending);
	eval 'sub schedule_timeout {
	    local($to) = @_;
    	    eval q( &do { ($current->{timeout}) =  &jiffies + ($to); &schedule ();}  &while (0));
	}' unless defined(&schedule_timeout);
	eval 'sub time_after {
	    local($t1,$t2) = @_;
    	    eval q((($t1-$t2) > 0));
	}' unless defined(&time_after);
    } else {
	require 'linux/compatmac.ph';
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >=  &KERNEL_VERSION(2,1,0)) {
	require 'linux/vmalloc.ph';
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,1,18)) {
	eval 'sub __USE_OLD_SYMTAB__ () {1;}' unless defined(&__USE_OLD_SYMTAB__);
	eval 'sub EXPORT_NO_SYMBOLS () { &register_symtab( &NULL);;}' unless defined(&EXPORT_NO_SYMBOLS);
	eval 'sub REGISTER_SYMTAB {
	    local($tab) = @_;
    	    eval q( &register_symtab($tab));
	}' unless defined(&REGISTER_SYMTAB);
    } else {
	eval 'sub REGISTER_SYMTAB {
	    local($tab) = @_;
    	    eval q();
	}' unless defined(&REGISTER_SYMTAB);
    }
    if(defined(&__USE_OLD_SYMTAB__)) {
	eval 'sub __MODULE_STRING {
	    local($s) = @_;
    	    eval q();
	}' unless defined(&__MODULE_STRING);
	eval 'sub MODULE_PARM {
	    local($v,$t) = @_;
    	    eval q();
	}' unless defined(&MODULE_PARM);
	eval 'sub MODULE_PARM_DESC {
	    local($v,$t) = @_;
    	    eval q();
	}' unless defined(&MODULE_PARM_DESC);
	eval 'sub MODULE_AUTHOR {
	    local($n) = @_;
    	    eval q();
	}' unless defined(&MODULE_AUTHOR);
	eval 'sub MODULE_DESCRIPTION {
	    local($d) = @_;
    	    eval q();
	}' unless defined(&MODULE_DESCRIPTION);
	eval 'sub MODULE_SUPPORTED_DEVICE {
	    local($n) = @_;
    	    eval q();
	}' unless defined(&MODULE_SUPPORTED_DEVICE);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >  &KERNEL_VERSION(2,1,22)) {
	require 'linux/poll.ph';
    } else {
	eval 'sub __USE_OLD_SELECT__ () {1;}' unless defined(&__USE_OLD_SELECT__);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >=  &KERNEL_VERSION(2,1,0)) {
	eval 'sub lseek_t () {\'long long\';}' unless defined(&lseek_t);
	eval 'sub lseek_off_t () {\'long long\';}' unless defined(&lseek_off_t);
    } else {
	eval 'sub lseek_t () {\'int\';}' unless defined(&lseek_t);
	eval 'sub lseek_off_t () { &off_t;}' unless defined(&lseek_off_t);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >=  &KERNEL_VERSION(2,1,0) || defined( &__alpha__)) {
	eval 'sub count_t () {\'unsigned long\';}' unless defined(&count_t);
	eval 'sub read_write_t () {\'long\';}' unless defined(&read_write_t);
    } else {
	eval 'sub count_t () {\'int\';}' unless defined(&count_t);
	eval 'sub read_write_t () {\'int\';}' unless defined(&read_write_t);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,1,31)) {
	eval 'sub release_t () { &void;}' unless defined(&release_t);
	eval 'sub release_return {
	    local($x) = @_;
    	    eval q( &return);
	}' unless defined(&release_return);
    } else {
	eval 'sub release_t () {\'int\';}' unless defined(&release_t);
	eval 'sub release_return {
	    local($x) = @_;
    	    eval q( &return ($x));
	}' unless defined(&release_return);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) < 0x20300) {
	eval 'sub __exit () {1;}' unless defined(&__exit);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) < 0x20200) {
	eval 'sub __init () {1;}' unless defined(&__init);
    } else {
	require 'linux/init.ph';
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,2,18)) {
	eval 'sub init_MUTEX {
	    local($x) = @_;
    	    eval q( &do {*($x) =  &MUTEX;}  &while (0));
	}' unless defined(&init_MUTEX);
	eval 'sub init_MUTEX_LOCKED {
	    local($x) = @_;
    	    eval q( &do {*($x) =  &MUTEX_LOCKED;}  &while (0));
	}' unless defined(&init_MUTEX_LOCKED);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,3,0)) {
	eval 'sub RQFUNC_ARG () { &void;}' unless defined(&RQFUNC_ARG);
	eval 'sub blkdev_dequeue_request {
	    local($req) = @_;
    	    eval q( &do { &CURRENT =  ($req->{next});}  &while (0));
	}' unless defined(&blkdev_dequeue_request);
    } else {
	eval 'sub RQFUNC_ARG () { &request_queue_t * &q;}' unless defined(&RQFUNC_ARG);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,3,32)) {
	eval 'sub blk_cleanup_queue {
	    local($nr) = @_;
    	    eval q( &do { ($blk_dev[$nr]->{request_fn}) = 0;}  &while(0));
	}' unless defined(&blk_cleanup_queue);
	eval 'sub BLK_DEFAULT_QUEUE {
	    local($nr) = @_;
    	    eval q(( ($blk_dev[$nr]->{request_fn})));
	}' unless defined(&BLK_DEFAULT_QUEUE);
	eval 'sub blk_init_queue {
	    local($q, $rq) = @_;
    	    eval q( &do {$q = $rq;}  &while(0));
	}' unless defined(&blk_init_queue);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,2,0)) {
	if(defined(&CONFIG_MODULES)) {
	    eval 'sub __MOD_INC_USE_COUNT {
	        local($mod) = @_;
    		eval q(( &atomic_inc(($mod)-> ($uc->{usecount})), ($mod)-> &flags |=  &MOD_VISITED| &MOD_USED_ONCE));
	    }' unless defined(&__MOD_INC_USE_COUNT);
	    eval 'sub __MOD_DEC_USE_COUNT {
	        local($mod) = @_;
    		eval q(( &atomic_dec(($mod)-> ($uc->{usecount})), ($mod)-> &flags |=  &MOD_VISITED));
	    }' unless defined(&__MOD_DEC_USE_COUNT);
	} else {
	    eval 'sub __MOD_INC_USE_COUNT {
	        local($mod) = @_;
    		eval q();
	    }' unless defined(&__MOD_INC_USE_COUNT);
	    eval 'sub __MOD_DEC_USE_COUNT {
	        local($mod) = @_;
    		eval q();
	    }' unless defined(&__MOD_DEC_USE_COUNT);
	}
    }
    unless(defined(&HAVE_INTER_MODULE)) {
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,2,18)) {
	eval 'sub DECLARE_WAIT_QUEUE_HEAD {
	    local($x) = @_;
    	    eval q(\'struct wait_queue\' *$x =  &NULL);
	}' unless defined(&DECLARE_WAIT_QUEUE_HEAD);
	eval 'sub init_waitqueue_head () { &init_waitqueue;}' unless defined(&init_waitqueue_head);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,3,0)) {
	if(defined(&CONFIG_MODULES)) {
	}
    }
    require 'asm/byteorder.ph';
    unless(defined(&__constant_cpu_to_le16)) {
	if(defined(&__BIG_ENDIAN)) {
	    eval 'sub __constant_cpu_to_le64 {
	        local($x) = @_;
    		eval q( &___swab64(($x)));
	    }' unless defined(&__constant_cpu_to_le64);
	    eval 'sub __constant_le64_to_cpu {
	        local($x) = @_;
    		eval q( &___swab64(($x)));
	    }' unless defined(&__constant_le64_to_cpu);
	    eval 'sub __constant_cpu_to_le32 {
	        local($x) = @_;
    		eval q( &___swab32(($x)));
	    }' unless defined(&__constant_cpu_to_le32);
	    eval 'sub __constant_le32_to_cpu {
	        local($x) = @_;
    		eval q( &___swab32(($x)));
	    }' unless defined(&__constant_le32_to_cpu);
	    eval 'sub __constant_cpu_to_le16 {
	        local($x) = @_;
    		eval q( &___swab16(($x)));
	    }' unless defined(&__constant_cpu_to_le16);
	    eval 'sub __constant_le16_to_cpu {
	        local($x) = @_;
    		eval q( &___swab16(($x)));
	    }' unless defined(&__constant_le16_to_cpu);
	    eval 'sub __constant_cpu_to_be64 {
	        local($x) = @_;
    		eval q((($x)));
	    }' unless defined(&__constant_cpu_to_be64);
	    eval 'sub __constant_be64_to_cpu {
	        local($x) = @_;
    		eval q((($x)));
	    }' unless defined(&__constant_be64_to_cpu);
	    eval 'sub __constant_cpu_to_be32 {
	        local($x) = @_;
    		eval q((($x)));
	    }' unless defined(&__constant_cpu_to_be32);
	    eval 'sub __constant_be32_to_cpu {
	        local($x) = @_;
    		eval q((($x)));
	    }' unless defined(&__constant_be32_to_cpu);
	    eval 'sub __constant_cpu_to_be16 {
	        local($x) = @_;
    		eval q((($x)));
	    }' unless defined(&__constant_cpu_to_be16);
	    eval 'sub __constant_be16_to_cpu {
	        local($x) = @_;
    		eval q((($x)));
	    }' unless defined(&__constant_be16_to_cpu);
	} else {
	    if(defined(&__LITTLE_ENDIAN)) {
		eval 'sub __constant_cpu_to_le64 {
		    local($x) = @_;
    		    eval q((($x)));
		}' unless defined(&__constant_cpu_to_le64);
		eval 'sub __constant_le64_to_cpu {
		    local($x) = @_;
    		    eval q((($x)));
		}' unless defined(&__constant_le64_to_cpu);
		eval 'sub __constant_cpu_to_le32 {
		    local($x) = @_;
    		    eval q((($x)));
		}' unless defined(&__constant_cpu_to_le32);
		eval 'sub __constant_le32_to_cpu {
		    local($x) = @_;
    		    eval q((($x)));
		}' unless defined(&__constant_le32_to_cpu);
		eval 'sub __constant_cpu_to_le16 {
		    local($x) = @_;
    		    eval q((($x)));
		}' unless defined(&__constant_cpu_to_le16);
		eval 'sub __constant_le16_to_cpu {
		    local($x) = @_;
    		    eval q((($x)));
		}' unless defined(&__constant_le16_to_cpu);
		eval 'sub __constant_cpu_to_be64 {
		    local($x) = @_;
    		    eval q( &___swab64(($x)));
		}' unless defined(&__constant_cpu_to_be64);
		eval 'sub __constant_be64_to_cpu {
		    local($x) = @_;
    		    eval q( &___swab64(($x)));
		}' unless defined(&__constant_be64_to_cpu);
		eval 'sub __constant_cpu_to_be32 {
		    local($x) = @_;
    		    eval q( &___swab32(($x)));
		}' unless defined(&__constant_cpu_to_be32);
		eval 'sub __constant_be32_to_cpu {
		    local($x) = @_;
    		    eval q( &___swab32(($x)));
		}' unless defined(&__constant_be32_to_cpu);
		eval 'sub __constant_cpu_to_be16 {
		    local($x) = @_;
    		    eval q( &___swab16(($x)));
		}' unless defined(&__constant_cpu_to_be16);
		eval 'sub __constant_be16_to_cpu {
		    local($x) = @_;
    		    eval q( &___swab16(($x)));
		}' unless defined(&__constant_be16_to_cpu);
	    } else {
		die("No\ \(recognised\)\ endianness\ defined\ \(unless\ it\,s\ PDP\)");
	    }
	}
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,3,0)) {
	eval 'sub mod_init_t () {\'int\'  &__init;}' unless defined(&mod_init_t);
	eval 'sub mod_exit_t () { &void;}' unless defined(&mod_exit_t);
    } else {
	eval 'sub mod_init_t () { &static \'int\'  &__init;}' unless defined(&mod_init_t);
	eval 'sub mod_exit_t () { &static  &void  &__exit;}' unless defined(&mod_exit_t);
    }
    unless(defined(&THIS_MODULE)) {
	if(defined(&MODULE)) {
	    eval 'sub THIS_MODULE () {(& &__this_module);}' unless defined(&THIS_MODULE);
	} else {
	    eval 'sub THIS_MODULE () {( &NULL);}' unless defined(&THIS_MODULE);
	}
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) < 0x20300) {
	require 'linux/interrupt.ph';
	eval 'sub spin_lock_bh {
	    local($lock) = @_;
    	    eval q( &do { &start_bh_atomic(); &spin_lock($lock);} &while(0));
	}' unless defined(&spin_lock_bh);
	eval 'sub spin_unlock_bh {
	    local($lock) = @_;
    	    eval q( &do { &spin_unlock($lock); &end_bh_atomic();} &while(0));
	}' unless defined(&spin_unlock_bh);
    } else {
	require 'asm/softirq.ph';
	require 'linux/spinlock.ph';
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,2,18)) {
	eval 'sub set_current_state {
	    local($state_value) = @_;
    	    eval q( &do {  ($current->{state}) = ($state_value); }  &while (0));
	}' unless defined(&set_current_state);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,2,0) ) {
    }
 elsif((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,4,5)) {
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,4,10)) {
	undef(&min) if defined(&min);
	undef(&max) if defined(&max);
	undef(&min_t) if defined(&min_t);
	undef(&max_t) if defined(&max_t);
	eval 'sub min {
	    local($x,$y) = @_;
    	    eval q(({  &const  &typeof  &_x = ;  &const  &typeof  &_y = ; (& &_x == & &_y);  &_x <  &_y ?  &_x :  &_y; }));
	}' unless defined(&min);
	eval 'sub max {
	    local($x,$y) = @_;
    	    eval q(({  &const  &typeof  &_x = ;  &const  &typeof  &_y = ; (& &_x == & &_y);  &_x >  &_y ?  &_x :  &_y; }));
	}' unless defined(&max);
	eval 'sub min_t {
	    local($type,$x,$y) = @_;
    	    eval q(({ $type  &__x = ($x); $type  &__y = ($y);  &__x <  &__y ?  &__x:  &__y; }));
	}' unless defined(&min_t);
	eval 'sub max_t {
	    local($type,$x,$y) = @_;
    	    eval q(({ $type  &__x = ($x); $type  &__y = ($y);  &__x >  &__y ?  &__x:  &__y; }));
	}' unless defined(&max_t);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,4,7)) {
	eval 'sub complete {
	    local($c) = @_;
    	    eval q( &up(($c)-> &s));
	}' unless defined(&complete);
	eval 'sub wait_for_completion {
	    local($c) = @_;
    	    eval q( &down(($c)-> &s));
	}' unless defined(&wait_for_completion);
	eval 'sub init_completion {
	    local($c) = @_;
    	    eval q( &init_MUTEX_LOCKED(($c)-> &s););
	}' unless defined(&init_completion);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,4,9)) {
	eval 'sub complete_and_exit {
	    local($c, $r) = @_;
    	    eval q( &do {  &complete($c);  &do_exit($r); }  &while(0));
	}' unless defined(&complete_and_exit);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,4,9) || ((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,4,10)  && !defined( &__rh_config_h__))) {
	require 'linux/genhd.ph';
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,2,18)  && defined( &MODULE)) {
	eval 'sub module_init {
	    local($func) = @_;
    	    eval q( &mod_init_t  &init_module( &void) {  &return $func(); });
	}' unless defined(&module_init);
	eval 'sub module_exit {
	    local($func) = @_;
    	    eval q( &mod_exit_t  &cleanup_module( &void) {  &return $func(); });
	}' unless defined(&module_exit);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,4,9) || ((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,4,10)  && !defined( &__rh_config_h__))) {
	eval 'sub MODULE_LICENSE {
	    local($x) = @_;
    	    eval q();
	}' unless defined(&MODULE_LICENSE);
    }
    if(0 && (defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,5,5)) {
	require 'linux/sched.ph';
	undef(&recalc_sigpending) if defined(&recalc_sigpending);
	eval 'sub recalc_sigpending () {
	    eval q( &__recalc_sigpending ());
	}' unless defined(&recalc_sigpending);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,5,5)) {
	eval 'sub parent_ino {
	    local($d) = @_;
    	    eval q((($d)-> ($d_parent->{d_inode}->{i_ino})));
	}' unless defined(&parent_ino);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,5,3)) {
	eval 'sub need_resched () {
	    eval q(( ($current->{need_resched})));
	}' unless defined(&need_resched);
	eval 'sub cond_resched () {
	    eval q( &do {  &if  &need_resched()  &schedule(); }  &while(0));
	}' unless defined(&cond_resched);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,4,19)) {
	unless(defined(&yield)) {
	    eval 'sub yield () {
	        eval q( &do {  &set_current_state( &TASK_RUNNING);  &schedule(); }  &while(0));
	    }' unless defined(&yield);
	}
	unless(defined(&minor)) {
	    eval 'sub major {
	        local($d) = @_;
    		eval q(( &MAJOR( &to_kdev_t($d))));
	    }' unless defined(&major);
	    eval 'sub minor {
	        local($d) = @_;
    		eval q(( &MINOR( &to_kdev_t($d))));
	    }' unless defined(&minor);
	}
	unless(defined(&mk_kdev)) {
	    eval 'sub mk_kdev {
	        local($ma,$mi) = @_;
    		eval q( &MKDEV($ma,$mi));
	    }' unless defined(&mk_kdev);
	    eval 'sub kdev_t_to_nr {
	        local($x) = @_;
    		eval q(($x));
	    }' unless defined(&kdev_t_to_nr);
	}
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,4,0)) {
	eval 'sub set_user_nice {
	    local($tsk, $n) = @_;
    	    eval q( &do { ($tsk)-> &priority = 20-($n); }  &while(0));
	}' unless defined(&set_user_nice);
    }
 elsif((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,4,21)  && !defined( &RED_HAT_LINUX_KERNEL)) {
	eval 'sub set_user_nice {
	    local($tsk, $n) = @_;
    	    eval q( &do { ($tsk)-> &nice = $n; }  &while(0));
	}' unless defined(&set_user_nice);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,4,21)) {
	eval 'sub rq_data_dir {
	    local($x) = @_;
    	    eval q((($x)-> &cmd));
	}' unless defined(&rq_data_dir);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,5,0)) {
	eval 'sub IS_REQ_CMD {
	    local($req) = @_;
    	    eval q((1));
	}' unless defined(&IS_REQ_CMD);
	eval 'sub QUEUE_LOCK {
	    local($q) = @_;
    	    eval q(( &io_request_lock));
	}' unless defined(&QUEUE_LOCK);
	eval 'sub BLK_INIT_QUEUE {
	    local($q, $req, $lock) = @_;
    	    eval q( &blk_init_queue(($q), ($req)));
	}' unless defined(&BLK_INIT_QUEUE);
    } else {
	eval 'sub IS_REQ_CMD {
	    local($req) = @_;
    	    eval q((($req)-> &flags &  &REQ_CMD));
	}' unless defined(&IS_REQ_CMD);
	eval 'sub QUEUE_LOCK {
	    local($q) = @_;
    	    eval q((($q)-> &queue_lock));
	}' unless defined(&QUEUE_LOCK);
	eval 'sub BLK_INIT_QUEUE {
	    local($q, $req, $lock) = @_;
    	    eval q( &blk_init_queue(($q), ($req), ($lock)));
	}' unless defined(&BLK_INIT_QUEUE);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) < 0x20300) {
	eval 'sub QUEUE_PLUGGED () {( ($blk_dev[&MAJOR_NR]->{plug_tq}->{sync}));}' unless defined(&QUEUE_PLUGGED);
    }
 elsif((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) < 0x20500 ) {
	eval 'sub QUEUE_PLUGGED () {( ($blk_dev[&MAJOR_NR]->{request_queue}->{plugged}));}' unless defined(&QUEUE_PLUGGED);
    } else {
	eval 'sub QUEUE_PLUGGED () {( &blk_queue_plugged( &QUEUE));}' unless defined(&QUEUE_PLUGGED);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,4,14)) {
	eval 'sub BLK_INC_USE_COUNT () { &MOD_INC_USE_COUNT;}' unless defined(&BLK_INC_USE_COUNT);
	eval 'sub BLK_DEC_USE_COUNT () { &MOD_DEC_USE_COUNT;}' unless defined(&BLK_DEC_USE_COUNT);
    } else {
	eval 'sub BLK_INC_USE_COUNT () { &do {}  &while(0);}' unless defined(&BLK_INC_USE_COUNT);
	eval 'sub BLK_DEC_USE_COUNT () { &do {}  &while(0);}' unless defined(&BLK_DEC_USE_COUNT);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,5,12)) {
	eval 'sub PageUptodate {
	    local($x) = @_;
    	    eval q( &Page_Uptodate($x));
	}' unless defined(&PageUptodate);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,5,48)) {
	eval 'sub get_seconds () {
	    eval q( &CURRENT_TIME);
	}' unless defined(&get_seconds);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,5,53)) {
	eval 'sub generic_file_readonly_mmap () { &generic_file_mmap;}' unless defined(&generic_file_readonly_mmap);
    }
}
1;
