require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&Py_OBJIMPL_H)) {
    eval 'sub Py_OBJIMPL_H () {1;}' unless defined(&Py_OBJIMPL_H);
    require 'pymem.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&WITH_PYMALLOC)) {
	if(defined(&PYMALLOC_DEBUG)) {
	    eval 'sub PyObject_MALLOC () { &_PyObject_DebugMalloc;}' unless defined(&PyObject_MALLOC);
	    eval 'sub PyObject_Malloc () { &_PyObject_DebugMalloc;}' unless defined(&PyObject_Malloc);
	    eval 'sub PyObject_REALLOC () { &_PyObject_DebugRealloc;}' unless defined(&PyObject_REALLOC);
	    eval 'sub PyObject_Realloc () { &_PyObject_DebugRealloc;}' unless defined(&PyObject_Realloc);
	    eval 'sub PyObject_FREE () { &_PyObject_DebugFree;}' unless defined(&PyObject_FREE);
	    eval 'sub PyObject_Free () { &_PyObject_DebugFree;}' unless defined(&PyObject_Free);
	} else {
	    eval 'sub PyObject_MALLOC () { &PyObject_Malloc;}' unless defined(&PyObject_MALLOC);
	    eval 'sub PyObject_REALLOC () { &PyObject_Realloc;}' unless defined(&PyObject_REALLOC);
	    eval 'sub PyObject_FREE () { &PyObject_Free;}' unless defined(&PyObject_FREE);
	}
    } else {
	eval 'sub PyObject_MALLOC () { &PyMem_MALLOC;}' unless defined(&PyObject_MALLOC);
	eval 'sub PyObject_REALLOC () { &PyMem_REALLOC;}' unless defined(&PyObject_REALLOC);
	eval 'sub PyObject_FREE () { &free;}' unless defined(&PyObject_FREE);
    }
    eval 'sub PyObject_Del () { &PyObject_Free;}' unless defined(&PyObject_Del);
    eval 'sub PyObject_DEL () { &PyObject_FREE;}' unless defined(&PyObject_DEL);
    eval 'sub _PyObject_Del () { &PyObject_Free;}' unless defined(&_PyObject_Del);
    eval 'sub PyObject_New {
        local($type, $typeobj) = @_;
	    eval q((  &_PyObject_New($typeobj) ));
    }' unless defined(&PyObject_New);
    eval 'sub PyObject_NewVar {
        local($type, $typeobj, $n) = @_;
	    eval q((  &_PyObject_NewVar(($typeobj), ($n)) ));
    }' unless defined(&PyObject_NewVar);
    eval 'sub PyObject_INIT {
        local($op, $typeobj) = @_;
	    eval q(( -> &ob_type = ,  &_Py_NewReference(($op)), ($op) ));
    }' unless defined(&PyObject_INIT);
    eval 'sub PyObject_INIT_VAR {
        local($op, $typeobj, $size) = @_;
	    eval q(( ($op)-> &ob_size = ($size),  &PyObject_INIT(($op), ($typeobj)) ));
    }' unless defined(&PyObject_INIT_VAR);
    eval 'sub _PyObject_SIZE {
        local($typeobj) = @_;
	    eval q(( ($typeobj)-> &tp_basicsize ));
    }' unless defined(&_PyObject_SIZE);
    if((((defined(&SIZEOF_VOID_P) ? &SIZEOF_VOID_P : 0) - 1) & (defined(&SIZEOF_VOID_P) ? &SIZEOF_VOID_P : 0)) != 0) {
	die("_PyObject_VAR_SIZE requires SIZEOF_VOID_P be a power of 2");
    }
    eval 'sub _PyObject_VAR_SIZE {
        local($typeobj, $nitems) = @_;
	    eval q( ( ( ($typeobj)-> &tp_basicsize + ($nitems)*($typeobj)-> &tp_itemsize + ( &SIZEOF_VOID_P - 1) ) & ~( &SIZEOF_VOID_P - 1) ));
    }' unless defined(&_PyObject_VAR_SIZE);
    eval 'sub PyObject_NEW {
        local($type, $typeobj) = @_;
	    eval q((  &PyObject_Init(  &PyObject_MALLOC(  &_PyObject_SIZE($typeobj) ), ($typeobj)) ));
    }' unless defined(&PyObject_NEW);
    eval 'sub PyObject_NEW_VAR {
        local($type, $typeobj, $n) = @_;
	    eval q((  &PyObject_InitVar(  &PyObject_MALLOC( &_PyObject_VAR_SIZE(($typeobj),($n)) ), ($typeobj), ($n)) ));
    }' unless defined(&PyObject_NEW_VAR);
    eval 'sub PyType_IS_GC {
        local($t) = @_;
	    eval q( &PyType_HasFeature(($t),  &Py_TPFLAGS_HAVE_GC));
    }' unless defined(&PyType_IS_GC);
    eval 'sub PyObject_IS_GC {
        local($o) = @_;
	    eval q(( &PyType_IS_GC(($o)-> &ob_type)  && (($o)-> ($ob_type->{tp_is_gc}) ==  &NULL || ($o)-> ($ob_type->{tp_is_gc})($o))));
    }' unless defined(&PyObject_IS_GC);
    eval 'sub PyObject_GC_Resize {
        local($type, $op, $n) = @_;
	    eval q((  &_PyObject_GC_Resize(($op), ($n)) ));
    }' unless defined(&PyObject_GC_Resize);
    eval 'sub _PyObject_GC_Del () { &PyObject_GC_Del;}' unless defined(&_PyObject_GC_Del);
    eval 'sub _Py_AS_GC {
        local($o) = @_;
	    eval q((($o)-1));
    }' unless defined(&_Py_AS_GC);
    eval 'sub _PyGC_REFS_UNTRACKED () {(-2);}' unless defined(&_PyGC_REFS_UNTRACKED);
    eval 'sub _PyGC_REFS_REACHABLE () {(-3);}' unless defined(&_PyGC_REFS_REACHABLE);
    eval 'sub _PyGC_REFS_TENTATIVELY_UNREACHABLE () {(-4);}' unless defined(&_PyGC_REFS_TENTATIVELY_UNREACHABLE);
    eval 'sub _PyObject_GC_TRACK {
        local($o) = @_;
	    eval q( &do {  &PyGC_Head * &g =  &_Py_AS_GC($o);  &if ( ($g->{gc}->{gc_refs}) !=  &_PyGC_REFS_UNTRACKED)  &Py_FatalError(\\"GC object already tracked\\");  ($g->{gc}->{gc_refs}) =  &_PyGC_REFS_REACHABLE;  ($g->{gc}->{gc_next}) =  &_PyGC_generation0;  ($g->{gc}->{gc_prev}) =  ($_PyGC_generation0->{gc}->{gc_prev});  ($g->{gc}->{gc_prev}->{gc}->{gc_next}) =  &g;  ($_PyGC_generation0->{gc}->{gc_prev}) =  &g; }  &while (0););
    }' unless defined(&_PyObject_GC_TRACK);
    eval 'sub _PyObject_GC_UNTRACK {
        local($o) = @_;
	    eval q( &do {  &PyGC_Head * &g =  &_Py_AS_GC($o);  &assert( ($g->{gc}->{gc_refs}) !=  &_PyGC_REFS_UNTRACKED);  ($g->{gc}->{gc_refs}) =  &_PyGC_REFS_UNTRACKED;  ($g->{gc}->{gc_prev}->{gc}->{gc_next}) =  ($g->{gc}->{gc_next});  ($g->{gc}->{gc_next}->{gc}->{gc_prev}) =  ($g->{gc}->{gc_prev});  ($g->{gc}->{gc_next}) =  &NULL; }  &while (0););
    }' unless defined(&_PyObject_GC_UNTRACK);
    eval 'sub PyObject_GC_New {
        local($type, $typeobj) = @_;
	    eval q((  &_PyObject_GC_New($typeobj) ));
    }' unless defined(&PyObject_GC_New);
    eval 'sub PyObject_GC_NewVar {
        local($type, $typeobj, $n) = @_;
	    eval q((  &_PyObject_GC_NewVar(($typeobj), ($n)) ));
    }' unless defined(&PyObject_GC_NewVar);
    eval 'sub PyGC_HEAD_SIZE () {0;}' unless defined(&PyGC_HEAD_SIZE);
    eval 'sub PyObject_GC_Init {
        local($op) = @_;
	    eval q();
    }' unless defined(&PyObject_GC_Init);
    eval 'sub PyObject_GC_Fini {
        local($op) = @_;
	    eval q();
    }' unless defined(&PyObject_GC_Fini);
    eval 'sub PyObject_AS_GC {
        local($op) = @_;
	    eval q(($op));
    }' unless defined(&PyObject_AS_GC);
    eval 'sub PyObject_FROM_GC {
        local($op) = @_;
	    eval q(($op));
    }' unless defined(&PyObject_FROM_GC);
    eval 'sub PyType_SUPPORTS_WEAKREFS {
        local($t) = @_;
	    eval q(( &PyType_HasFeature(($t),  &Py_TPFLAGS_HAVE_WEAKREFS)  && (($t)-> &tp_weaklistoffset > 0)));
    }' unless defined(&PyType_SUPPORTS_WEAKREFS);
    eval 'sub PyObject_GET_WEAKREFS_LISTPTR {
        local($o) = @_;
	    eval q(( (( ($o)) + ($o)-> ($ob_type->{tp_weaklistoffset}))));
    }' unless defined(&PyObject_GET_WEAKREFS_LISTPTR);
    if(defined(&__cplusplus)) {
    }
}
1;
