require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&Py_CURSES_H)) {
    eval 'sub Py_CURSES_H () {1;}' unless defined(&Py_CURSES_H);
    if(defined(&__APPLE__)) {
	if(defined(&_BSD_WCHAR_T_DEFINED_)) {
	    eval 'sub _WCHAR_T () {1;}' unless defined(&_WCHAR_T);
	}
    }
    if(defined(&__FreeBSD__)) {
	if(defined(&_XOPEN_SOURCE_EXTENDED)) {
	    unless(defined(&__FreeBSD_version)) {
		require 'osreldate.ph';
	    }
	    if((defined(&__FreeBSD_version) ? &__FreeBSD_version : 0) >= 500000) {
		unless(defined(&__wchar_t)) {
		    eval 'sub __wchar_t () {1;}' unless defined(&__wchar_t);
		}
		unless(defined(&__wint_t)) {
		    eval 'sub __wint_t () {1;}' unless defined(&__wint_t);
		}
	    } else {
		unless(defined(&_WCHAR_T)) {
		    eval 'sub _WCHAR_T () {1;}' unless defined(&_WCHAR_T);
		}
		unless(defined(&_WINT_T)) {
		    eval 'sub _WINT_T () {1;}' unless defined(&_WINT_T);
		}
	    }
	}
    }
    if(defined(&HAVE_NCURSES_H)) {
	require 'ncurses.ph';
    } else {
	require 'curses.ph';
	if(defined(&HAVE_TERM_H)) {
	    require 'term.ph';
	}
    }
    if(defined(&HAVE_NCURSES_H)) {
	unless(defined(&WINDOW_HAS_FLAGS)) {
	    eval 'sub WINDOW_HAS_FLAGS () {1;}' unless defined(&WINDOW_HAS_FLAGS);
	}
	unless(defined(&MVWDELCH_IS_EXPRESSION)) {
	    eval 'sub MVWDELCH_IS_EXPRESSION () {1;}' unless defined(&MVWDELCH_IS_EXPRESSION);
	}
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub PyCurses_API_pointers () {4;}' unless defined(&PyCurses_API_pointers);
    eval 'sub PyCursesWindow_Check {
        local($v) = @_;
	    eval q((($v)-> &ob_type ==  &PyCursesWindow_Type));
    }' unless defined(&PyCursesWindow_Check);
    if(defined(&CURSES_MODULE)) {
    } else {
	eval 'sub PyCursesWindow_Type () {(*  $PyCurses_API[0]);}' unless defined(&PyCursesWindow_Type);
	eval 'sub PyCursesSetupTermCalled () {{ &if (! (( &int (*)( &void)) $PyCurses_API[1]) () )  &return  &NULL;};}' unless defined(&PyCursesSetupTermCalled);
	eval 'sub PyCursesInitialised () {{ &if (! (( &int (*)( &void)) $PyCurses_API[2]) () )  &return  &NULL;};}' unless defined(&PyCursesInitialised);
	eval 'sub PyCursesInitialisedColor () {{ &if (! (( &int (*)( &void)) $PyCurses_API[3]) () )  &return  &NULL;};}' unless defined(&PyCursesInitialisedColor);
	eval 'sub import_curses () {
	    eval q({  &PyObject * &module =  &PyImport_ImportModule(\\"_curses\\");  &if ( &module !=  &NULL) {  &PyObject * &module_dict =  &PyModule_GetDict;  &PyObject * &c_api_object =  &PyDict_GetItemString( &module_dict, \\"_C_API\\");  &if {  &PyCurses_API =  &PyCObject_AsVoidPtr( &c_api_object); } } });
	}' unless defined(&import_curses);
    }
    eval 'sub NoArgNoReturnFunction {
        local($X) = @_;
	    eval q( &static  &PyObject * &PyCurses_  $X ( &PyObject * &self) {  &PyCursesInitialised  &return  &PyCursesCheckERR($X(),  $X); });
    }' unless defined(&NoArgNoReturnFunction);
    eval 'sub NoArgOrFlagNoReturnFunction {
        local($X) = @_;
	    eval q( &static  &PyObject * &PyCurses_  $X ( &PyObject * &self,  &PyObject * &args) { \'int\'  &flag = 0;  &PyCursesInitialised  &switch {  &case 0:  &return  &PyCursesCheckERR($X(),  $X);  &case 1:  &if (! &PyArg_ParseTuple( &args, \\"i;True or False\\",  &flag))  &return  &NULL;  &if  &return  &PyCursesCheckERR($X(),  $X);  &else  &return  &PyCursesCheckERR( &no  $X (),  $X);  &default:  &PyErr_SetString( &PyExc_TypeError,  $X \\" requires 0 or 1 arguments\\");  &return  &NULL; } });
    }' unless defined(&NoArgOrFlagNoReturnFunction);
    eval 'sub NoArgReturnIntFunction {
        local($X) = @_;
	    eval q( &static  &PyObject * &PyCurses_  $X ( &PyObject * &self) {  &PyCursesInitialised  &return  &PyInt_FromLong( $X()); });
    }' unless defined(&NoArgReturnIntFunction);
    eval 'sub NoArgReturnStringFunction {
        local($X) = @_;
	    eval q( &static  &PyObject * &PyCurses_  $X ( &PyObject * &self) {  &PyCursesInitialised  &return  &PyString_FromString($X()); });
    }' unless defined(&NoArgReturnStringFunction);
    eval 'sub NoArgTrueFalseFunction {
        local($X) = @_;
	    eval q( &static  &PyObject * &PyCurses_  $X ( &PyObject * &self) {  &PyCursesInitialised  &if ($X () ==  &FALSE) {  &Py_INCREF( &Py_False);  &return  &Py_False; }  &Py_INCREF( &Py_True);  &return  &Py_True; });
    }' unless defined(&NoArgTrueFalseFunction);
    eval 'sub NoArgNoReturnVoidFunction {
        local($X) = @_;
	    eval q( &static  &PyObject * &PyCurses_  $X ( &PyObject * &self) {  &PyCursesInitialised $X();  &Py_INCREF( &Py_None);  &return  &Py_None; });
    }' unless defined(&NoArgNoReturnVoidFunction);
    if(defined(&__cplusplus)) {
    }
}
1;
