require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&Py_PYPORT_H)) {
    eval 'sub Py_PYPORT_H () {1;}' unless defined(&Py_PYPORT_H);
    require 'pyconfig.ph';
    if(defined(&HAVE_PROTOTYPES)) {
	eval 'sub Py_PROTO {
	    local($x) = @_;
    	    eval q($x);
	}' unless defined(&Py_PROTO);
    } else {
	eval 'sub Py_PROTO {
	    local($x) = @_;
    	    eval q(());
	}' unless defined(&Py_PROTO);
    }
    unless(defined(&Py_FPROTO)) {
	eval 'sub Py_FPROTO {
	    local($x) = @_;
    	    eval q( &Py_PROTO($x));
	}' unless defined(&Py_FPROTO);
    }
    if(defined(&HAVE_LONG_LONG)) {
	unless(defined(&PY_LONG_LONG)) {
	    eval 'sub PY_LONG_LONG () {\'long long\';}' unless defined(&PY_LONG_LONG);
	}
    }
    if(defined(&HAVE_UINTPTR_T)) {
    }
 elsif((defined(&SIZEOF_VOID_P) ? &SIZEOF_VOID_P : 0) <= (defined(&SIZEOF_INT) ? &SIZEOF_INT : 0)) {
    }
 elsif((defined(&SIZEOF_VOID_P) ? &SIZEOF_VOID_P : 0) <= (defined(&SIZEOF_LONG) ? &SIZEOF_LONG : 0)) {
    }
 elsif(defined( &HAVE_LONG_LONG)  && ((defined(&SIZEOF_VOID_P) ? &SIZEOF_VOID_P : 0) <= (defined(&SIZEOF_LONG_LONG) ? &SIZEOF_LONG_LONG : 0))) {
    } else {
	die("Python needs a typedef for Py_uintptr_t in pyport.h.");
    }
    if(defined(&HAVE_STDLIB_H)) {
	require 'stdlib.ph';
    }
    require 'math.ph';
    if(defined(&TIME_WITH_SYS_TIME)) {
	require 'sys/time.ph';
	require 'time.ph';
    } else {
	if(defined(&HAVE_SYS_TIME_H)) {
	    require 'sys/time.ph';
	} else {
	    require 'time.ph';
	}
    }
    if(defined(&HAVE_SYS_SELECT_H)) {
	require 'sys/select.ph';
    }
    unless(defined(&DONT_HAVE_STAT)) {
	eval 'sub HAVE_STAT () {1;}' unless defined(&HAVE_STAT);
    }
    unless(defined(&DONT_HAVE_FSTAT)) {
	eval 'sub HAVE_FSTAT () {1;}' unless defined(&HAVE_FSTAT);
    }
    if(defined(&RISCOS)) {
	require 'sys/types.ph';
	require 'unixstuff.ph';
    }
    unless(defined(&DONT_HAVE_SYS_STAT_H)) {
	if(defined( &PYOS_OS2)  && defined( &PYCC_GCC)) {
	    require 'sys/types.ph';
	}
	require 'sys/stat.ph';
    }
 elsif(defined( &HAVE_STAT_H)) {
	require 'stat.ph';
    }
    if(defined( &PYCC_VACPP)) {
	eval 'sub S_IFMT () {( &S_IFDIR| &S_IFCHR| &S_IFREG);}' unless defined(&S_IFMT);
    }
    unless(defined(&S_ISREG)) {
	eval 'sub S_ISREG {
	    local($x) = @_;
    	    eval q(((($x) &  &S_IFMT) ==  &S_IFREG));
	}' unless defined(&S_ISREG);
    }
    unless(defined(&S_ISDIR)) {
	eval 'sub S_ISDIR {
	    local($x) = @_;
    	    eval q(((($x) &  &S_IFMT) ==  &S_IFDIR));
	}' unless defined(&S_ISDIR);
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&SIGNED_RIGHT_SHIFT_ZERO_FILLS)) {
	eval 'sub Py_ARITHMETIC_RIGHT_SHIFT {
	    local($TYPE, $I, $J) = @_;
    	    eval q(( < 0? ~((~($I)) >> ($J)) : ($I) >> ($J)));
	}' unless defined(&Py_ARITHMETIC_RIGHT_SHIFT);
    } else {
	eval 'sub Py_ARITHMETIC_RIGHT_SHIFT {
	    local($TYPE, $I, $J) = @_;
    	    eval q((($I) >> ($J)));
	}' unless defined(&Py_ARITHMETIC_RIGHT_SHIFT);
    }
    eval 'sub Py_FORCE_EXPANSION {
        local($X) = @_;
	    eval q($X);
    }' unless defined(&Py_FORCE_EXPANSION);
    if(defined(&Py_DEBUG)) {
	eval 'sub Py_SAFE_DOWNCAST {
	    local($VALUE, $WIDE, $NARROW) = @_;
    	    eval q(( &assert( == ), ($VALUE)));
	}' unless defined(&Py_SAFE_DOWNCAST);
    } else {
	eval 'sub Py_SAFE_DOWNCAST {
	    local($VALUE, $WIDE, $NARROW) = @_;
    	    eval q(($VALUE));
	}' unless defined(&Py_SAFE_DOWNCAST);
    }
    eval 'sub Py_IS_INFINITY {
        local($X) = @_;
	    eval q((($X)  && ($X)*0.5== ($X)));
    }' unless defined(&Py_IS_INFINITY);
    unless(defined(&Py_HUGE_VAL)) {
	eval 'sub Py_HUGE_VAL () { &HUGE_VAL;}' unless defined(&Py_HUGE_VAL);
    }
    if(defined( &__FreeBSD__) || defined( &__OpenBSD__)) {
	eval 'sub Py_OVERFLOWED {
	    local($X) = @_;
    	    eval q( &isinf($X));
	}' unless defined(&Py_OVERFLOWED);
    } else {
	eval 'sub Py_OVERFLOWED {
	    local($X) = @_;
    	    eval q((($X) != 0.0 && ( &errno ==  &ERANGE || ($X) ==  &Py_HUGE_VAL || ($X) == - &Py_HUGE_VAL)));
	}' unless defined(&Py_OVERFLOWED);
    }
    eval 'sub Py_SET_ERANGE_IF_OVERFLOW {
        local($X) = @_;
	    eval q( &do {  &if ( &errno == 0 && (($X) ==  &Py_HUGE_VAL || ($X) == - &Py_HUGE_VAL))  &errno =  &ERANGE; }  &while(0));
    }' unless defined(&Py_SET_ERANGE_IF_OVERFLOW);
    eval 'sub Py_ADJUST_ERANGE1 {
        local($X) = @_;
	    eval q( &do {  &if ( &errno == 0) {  &if (($X) ==  &Py_HUGE_VAL || ($X) == - &Py_HUGE_VAL)  &errno =  &ERANGE; }  &else  &if ( &errno ==  &ERANGE  && ($X) == 0.0)  &errno = 0; }  &while(0));
    }' unless defined(&Py_ADJUST_ERANGE1);
    eval 'sub Py_ADJUST_ERANGE2 {
        local($X, $Y) = @_;
	    eval q( &do {  &if (($X) ==  &Py_HUGE_VAL || ($X) == - &Py_HUGE_VAL || ($Y) ==  &Py_HUGE_VAL || ($Y) == - &Py_HUGE_VAL) {  &if ( &errno == 0)  &errno =  &ERANGE; }  &else  &if ( &errno ==  &ERANGE)  &errno = 0; }  &while(0));
    }' unless defined(&Py_ADJUST_ERANGE2);
    if(defined( &__GNUC__)  && ((defined(&__GNUC__) ? &__GNUC__ : 0) == 3)  && ((defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) >= 1)) {
	eval 'sub Py_DEPRECATED {
	    local($VERSION_UNUSED) = @_;
    	    eval q( &__attribute__(( &__deprecated__)));
	}' unless defined(&Py_DEPRECATED);
    } else {
	eval 'sub Py_DEPRECATED {
	    local($VERSION_UNUSED) = @_;
    	    eval q();
	}' unless defined(&Py_DEPRECATED);
    }
    if(defined(&SOLARIS)) {
    }
    if(defined(&__BEOS__)) {
    }
    if(defined(&HAVE__GETPTY)) {
	require 'sys/types.ph';
    }
    if(defined( &HAVE_OPENPTY) || defined( &HAVE_FORKPTY)) {
	if(!defined( &HAVE_PTY_H)  && !defined( &HAVE_LIBUTIL_H)) {
	    require 'termios.ph';
	}
    }
    if(0) {
    }
    unless(defined(&HAVE_HYPOT)) {
    }
    if(defined( &__CYGWIN__) || defined( &__BEOS__)) {
	eval 'sub HAVE_DECLSPEC_DLL () {1;}' unless defined(&HAVE_DECLSPEC_DLL);
    }
    if(defined( &Py_ENABLE_SHARED) ) {
	if(defined( &HAVE_DECLSPEC_DLL)) {
	    if(defined(&Py_BUILD_CORE)) {
		eval 'sub PyAPI_FUNC {
		    local($RTYPE) = @_;
    		    eval q( &__declspec $RTYPE);
		}' unless defined(&PyAPI_FUNC);
		eval 'sub PyAPI_DATA {
		    local($RTYPE) = @_;
    		    eval q( &extern  &__declspec $RTYPE);
		}' unless defined(&PyAPI_DATA);
		eval 'sub PyMODINIT_FUNC () { &void;}' unless defined(&PyMODINIT_FUNC);
	    } else {
		if(!defined( &__CYGWIN__)) {
		    eval 'sub PyAPI_FUNC {
		        local($RTYPE) = @_;
    			eval q( &__declspec $RTYPE);
		    }' unless defined(&PyAPI_FUNC);
		}
		eval 'sub PyAPI_DATA {
		    local($RTYPE) = @_;
    		    eval q( &extern  &__declspec $RTYPE);
		}' unless defined(&PyAPI_DATA);
		if(defined( &__cplusplus)) {
		    eval 'sub PyMODINIT_FUNC () { &extern "C"  &__declspec  &void;}' unless defined(&PyMODINIT_FUNC);
		} else {
		    eval 'sub PyMODINIT_FUNC () { &__declspec  &void;}' unless defined(&PyMODINIT_FUNC);
		}
	    }
	}
    }
    unless(defined(&PyAPI_FUNC)) {
	eval 'sub PyAPI_FUNC {
	    local($RTYPE) = @_;
    	    eval q($RTYPE);
	}' unless defined(&PyAPI_FUNC);
    }
    unless(defined(&PyAPI_DATA)) {
	eval 'sub PyAPI_DATA {
	    local($RTYPE) = @_;
    	    eval q( &extern $RTYPE);
	}' unless defined(&PyAPI_DATA);
    }
    unless(defined(&PyMODINIT_FUNC)) {
	if(defined( &__cplusplus)) {
	    eval 'sub PyMODINIT_FUNC () { &extern "C"  &void;}' unless defined(&PyMODINIT_FUNC);
	} else {
	    eval 'sub PyMODINIT_FUNC () { &void;}' unless defined(&PyMODINIT_FUNC);
	}
    }
    if(defined( &Py_ENABLE_SHARED)  && defined ( &HAVE_DECLSPEC_DLL)) {
	if(defined( &Py_BUILD_CORE)) {
	    eval 'sub DL_IMPORT {
	        local($RTYPE) = @_;
    		eval q( &__declspec $RTYPE);
	    }' unless defined(&DL_IMPORT);
	    eval 'sub DL_EXPORT {
	        local($RTYPE) = @_;
    		eval q( &__declspec $RTYPE);
	    }' unless defined(&DL_EXPORT);
	} else {
	    eval 'sub DL_IMPORT {
	        local($RTYPE) = @_;
    		eval q( &__declspec $RTYPE);
	    }' unless defined(&DL_IMPORT);
	    eval 'sub DL_EXPORT {
	        local($RTYPE) = @_;
    		eval q( &__declspec $RTYPE);
	    }' unless defined(&DL_EXPORT);
	}
    }
    unless(defined(&DL_EXPORT)) {
	eval 'sub DL_EXPORT {
	    local($RTYPE) = @_;
    	    eval q($RTYPE);
	}' unless defined(&DL_EXPORT);
    }
    unless(defined(&DL_IMPORT)) {
	eval 'sub DL_IMPORT {
	    local($RTYPE) = @_;
    	    eval q($RTYPE);
	}' unless defined(&DL_IMPORT);
    }
    if(0) {
	unless(defined(&FD_SETSIZE)) {
	    eval 'sub FD_SETSIZE () {256;}' unless defined(&FD_SETSIZE);
	}
	unless(defined(&FD_SET)) {
	    eval 'sub NFDBITS () {($sizeof{ &fd_mask} *  &NBBY);}' unless defined(&NFDBITS);
	    unless(defined(&howmany)) {
		eval 'sub howmany {
		    local($x, $y) = @_;
    		    eval q(((($x)+(($y)-1))/($y)));
		}' unless defined(&howmany);
	    }
	    eval 'sub FD_SET {
	        local($n, $p) = @_;
    		eval q((($p)-> $fds_bits[($n)/ &NFDBITS] |= (1<< (($n) %  &NFDBITS))));
	    }' unless defined(&FD_SET);
	    eval 'sub FD_CLR {
	        local($n, $p) = @_;
    		eval q((($p)-> $fds_bits[($n)/ &NFDBITS] &= ~(1<< (($n) %  &NFDBITS))));
	    }' unless defined(&FD_CLR);
	    eval 'sub FD_ISSET {
	        local($n, $p) = @_;
    		eval q((($p)-> $fds_bits[($n)/ &NFDBITS] & (1<< (($n) %  &NFDBITS))));
	    }' unless defined(&FD_ISSET);
	    eval 'sub FD_ZERO {
	        local($p) = @_;
    		eval q( &memset(($p), ord(\'\\\\0\'), $sizeof{($p)}));
	    }' unless defined(&FD_ZERO);
	}
    }
    unless(defined(&INT_MAX)) {
	eval 'sub INT_MAX () {2147483647;}' unless defined(&INT_MAX);
    }
    unless(defined(&LONG_MAX)) {
	if((defined(&SIZEOF_LONG) ? &SIZEOF_LONG : 0) == 4) {
	    eval 'sub LONG_MAX () {0x7fffffff;}' unless defined(&LONG_MAX);
	}
 elsif((defined(&SIZEOF_LONG) ? &SIZEOF_LONG : 0) == 8) {
	    eval 'sub LONG_MAX () {0x7fffffffffffffff;}' unless defined(&LONG_MAX);
	} else {
	    die("could not set LONG_MAX in pyport.h");
	}
    }
    unless(defined(&LONG_MIN)) {
	eval 'sub LONG_MIN () {(- &LONG_MAX-1);}' unless defined(&LONG_MIN);
    }
    unless(defined(&LONG_BIT)) {
	eval 'sub LONG_BIT () {(8*  &SIZEOF_LONG);}' unless defined(&LONG_BIT);
    }
    if((defined(&LONG_BIT) ? &LONG_BIT : 0) != 8* (defined(&SIZEOF_LONG) ? &SIZEOF_LONG : 0)) {
	die("LONG_BIT definition appears wrong for platform (bad gcc/glibc config?).");
    }
    if(defined(&__cplusplus)) {
    }
    if((!defined( &__GNUC__) || (defined(&__GNUC__) ? &__GNUC__ : 0) < 2|| ((defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) < 7) )  && !defined( &RISCOS)) {
	eval 'sub Py_GCC_ATTRIBUTE {
	    local($x) = @_;
    	    eval q();
	}' unless defined(&Py_GCC_ATTRIBUTE);
    } else {
	eval 'sub Py_GCC_ATTRIBUTE {
	    local($x) = @_;
    	    eval q( &__attribute__($x));
	}' unless defined(&Py_GCC_ATTRIBUTE);
    }
}
1;
